<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Wallpapers
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Wallpapers
{

	var $class;
	var $PerPage = 28;
	var $pending = false;

	//---------------------------------------------------------------
	// auto_run
	// Default function called by parent class.
	//---------------------------------------------------------------

	function auto_run()
	{
		Functions::$Var['Selected'] = 2;

		//-----------------------------------------------------------
		// Are we performing any action?
		//-----------------------------------------------------------

		switch($this->class->main->Data("action"))
		{
			case 'delete':
				return $this->delete();
				break;
			case 'approve':
				return $this->app_dis(1);
				break;
			case 'disapprove':
				return $this->app_dis(0);
				break;
		}

		/*Note:	I had to do two switch statements. One for 'action' and one for 'do'.
				Ran in to issues when submitting form with javascript. This was easiest solution. */

		//-----------------------------------------------------------
		// What are we doing?
		//-----------------------------------------------------------

		switch($this->class->main->Data("do"))
		{
			case 'delete':
				return $this->delete();
				break;
			case 'confirm_delete':
				return $this->confirm_delete();
				break;
			case 'pending':
				return $this->manage('pending');
				break;
			case 'categories':
				return $this->categories();
				break;
			case 'new_cat':
				return $this->new_cat();
				break;
			case 'delete_cats':
				return $this->delete_cats();
				break;
			case 'create_cat':
				return $this->create_cat();
				break;
			case 'confirm_delete_cats':
				return $this->confirm_delete_cats();
				break;
			case 'editcat':
			case 'edit_cat':
				return $this->edit_cat();
				break;
			case 'edit_cat_submit':
				return $this->edit_cat_submit();
				break;
			case 'bulk':
				return $this->bulk();
				break;
			case 'submit_bulk':
				return $this->submit_bulk();
				break;
			case 'start_bulk':
				return $this->start_bulk();
				break;
			case 'status_bulk':
				return $this->status_bulk();
				break;
			case 'delete_bulk':
				return $this->delete_bulk();
				break;
			case 'add':
				return $this->add_wallpaper();
				break;
			case 'submit_upload':
				return $this->submit_upload();
				break;
			case 'edit':
				return $this->edit_wallpaper();
				break;
			case 'submit_edit':
				return $this->submit_edit();
				break;
			case 'watermark':
				return $this->watermark();
				break;
			case 'submit_watermark':
				return $this->submit_watermark();
				break;

			default:
				return $this->manage();
				break;
		}
	

	}

	//---------------------------------------------------------------
	// Manage wallpapers
	// List wallpapers, as well as management options (delete, approve, etc.)
	//---------------------------------------------------------------

	function manage($do = '')
	{

		// Declare variables
		$q = null;
		$w = null;
		$c = null;

		//-----------------------------------------------------------
		// Do we have search paramaters?
		//-----------------------------------------------------------

		$Paramaters = array();

		if($this->class->main->Data("n") != null)
			$Paramaters[] = "wallpapers.name LIKE '%" . $this->class->main->Data("n") . "%'";

		if($this->class->main->Data("a") != null)
			$Paramaters[] = "`author` LIKE '%" . $this->class->main->Data("a") . "%'";

		if($this->class->main->Data("c") != null)
			$Paramaters[] = "`cat` = ". $this->class->main->Data("c") . " OR `parent` = " . $this->class->main->Data("c");

		foreach($Paramaters as $Where)
			$q .= '(' . $Where . ') AND ';

		if(count($Paramaters) > 0)
			$q = 'WHERE ' . substr($q, 0, strlen($q) - 4);

		//-----------------------------------------------------------
		// Pagination
		//-----------------------------------------------------------

		if($this->class->main->Data("c") != null)
		{
			$Cat = $this->class->main->Data("c");

			// Select the categories
			$Query = "SELECT `id` FROM `categories` WHERE `id` = " . $Cat . " OR `parent` = " . $Cat;
			$Result = $this->class->main->mysql->Query($Query);
			$Cats = $this->class->main->mysql->FetchResults($Result);

			$c = "(";
			foreach($Cats as $Cat)
				$c .= "`cat` = " . $Cat['id'] . " OR ";

			// Replace the category SQL in original query, would have made what I'm trying to do impossible.
			$c = ' WHERE '.substr($c, 0, strlen($c) - 4);
			$c .= ")";

		}
		
		// Are we viewing pending wallpapers?
		if($do == 'pending')
			$q = ' WHERE `status` = 0 '; 

		//-----------------------------------------------------------
		// Pagination still, finding the count
		//-----------------------------------------------------------

		// Replace ugly query
		preg_match_all('/ \(`cat` \= .* OR `parent` \= .*/', $q, $res);
		if(array_key_exists(0, $res) && array_key_exists(0, $res[0])) 
			$w = str_replace($res[0][0], null, $q);

		if($do != 'pending')
			$w .= str_replace('WHERE ', null, $c);
		
		// How many wallpapers are there in total?
		$Query = "SELECT COUNT(*) FROM `wallpapers` " . $w . " ORDER BY wallpapers.id DESC";
		$Result = $this->class->main->mysql->Query($Query);
		$Count = $this->class->main->mysql->FetchResults($Result);
		$Count = $Count[0]['COUNT(*)'];

		// How many pages?
		$Pages = ceil($Count / $this->PerPage);
		$Page = $this->class->main->Data("page");
		$Page = ( $Page == null || ! is_numeric($Page) ) ? 1 : $Page;

		// URL Setting
		$Query = preg_replace('/\&page\=\d+/', null, $_SERVER['QUERY_STRING']);
		Functions::$Var['class']->lang->Phrase['url'] = 'index.php?' . $Query;

		$tmp = Functions::pagHTML($Page, $Pages, 'ext', 'pag/pag_');
		
		//-----------------------------------------------------------
		// Retrieve the wallpapers
		//-----------------------------------------------------------

		$Start = ($Page - 1) * $this->PerPage;
		$Query = "SELECT wallpapers.id, wallpapers.cat, wallpapers.name, wallpapers.views, wallpapers.time, wallpapers.author, wallpapers.downloads, wallpapers.status, categories.parent, COUNT(*) FROM `wallpapers` INNER JOIN `categories` ON wallpapers.cat = categories.id " . $q . "GROUP BY wallpapers.id ORDER BY wallpapers.id DESC LIMIT " . $Start . ", " . $this->PerPage;
		$Result = $this->class->main->mysql->Query($Query);
		$Wallpapers = $this->class->main->mysql->FetchResults($Result);

		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wallpaper_table_start", array());

		// Loop through the wallpapers
		foreach($Wallpapers as $id => $Wallpaper)
		{
			// Alternating rows html
			$class = ($id % 2) == 0 ? 'first' : 'second';

			// Submitted by a guest or actual member?
			$Wallpaper['raw_author'] = $Wallpaper['author'];
			if($Wallpaper['author'] == '') $Wallpaper['author'] = '<i>Guest</i>';
			else $Wallpaper['author'] = '<a href="index.php?act=members&do=user&u='.$Wallpaper['author'].'">'.$Wallpaper['author'].'</a>';

			// Load the row template
			$tbl .= Functions::LoadTemplate("wallpaper_table_entry", array_merge($Wallpaper, array(
				'class'			=> $class,
				'status'		=> $Wallpaper['status'] == 0 ? 'Pending' : 'Approved',
			)));
		}

		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("wallpaper_table_options", array());

		// Wrap it up in a form
		$form = Functions::LoadTemplate("form", array('action' => '?act=wallpapers&do=submit_manage', 'method' => 'post', 'id' => 'manage_wp_form', 'content' => $tbl));

		// Build the table section
		$Title = count($Paramaters) > 0 ? 'Search' : 'Manage';
		$Title = $do == null ? $Title : 'Pending';

		// Title of the section
		$Title .= ' Wallpapers';
		if($Page > 1) $Title .= " - Page " . $Page;

		// Build it from the template
		$Section = Functions::BuildSection($Title, $form, array('table' => 1));

		// Pagination
		$Section .= $tmp;

		//-----------------------------------------------------------
		// Build the search side panel
		//-----------------------------------------------------------

		// Grab the categories
		$Options = Functions::CategoriesOptions();

		// Load search form template
		if($do == null)
		{
			$Search = Functions::LoadTemplate("manage_search", array('Options' => $Options));
			$Search = Functions::LoadTemplate("form", array('action' => '?act=wallpapers&do=search', 'method' => 'get', 'id' => 'manage_search', 'content' => $Search));
			Functions::$Var['side_panel'] = Functions::LoadTemplate("side_section", array('title' => 'Search Wallpapers', 'content' => $Search));
		}

		return $Section;
	}

	//---------------------------------------------------------------
	// Approve/Dissaprove
	// Toggle wallpaper display options. Called from manage()
	//---------------------------------------------------------------

	function app_dis($val)
	{
		Functions::DemoCheck();

		// Did we select anything?
		if (array_key_exists('wallpapers', $_REQUEST) == false || count($_REQUEST['wallpapers']) == 0)
			Functions::AdminError("You must select at least one wallpaper.");

		// Loop through wallpapers
		$Query = array();
		foreach($_REQUEST['wallpapers'] as $id)
			if($id != null && !is_array($id) && is_numeric($id))
				$Query[] = "UPDATE `wallpapers` SET `status` = " . $val . " WHERE `id` = ".$id;

		// Execute mysql queries
		foreach($Query as $q)
			$this->class->main->mysql->Query($q);
		
		// Changes made, lets redirect.
		$URL = Functions::str_contains($_SERVER['HTTP_REFERER'], 'do=pending') ? 'pending' : 'manage';
		Functions::Redirect( 'Your changed has been made', 'index.php?act=wallpapers&do=' . $URL );
	}

	//---------------------------------------------------------------
	// Delete a wallpaper
	// Outputs confirmation screen prior to deleting
	//---------------------------------------------------------------

	function delete()
	{
		// Are we deleting a single wallpaper? (i.e. did we click the delete icon)
		if (array_key_exists('id', $_REQUEST) != false && count($_REQUEST['id']) != 0)
			$_REQUEST['wallpapers'][0] = $_REQUEST['id'];

		// Are we deleting multiple wallpapers?
		if (array_key_exists('wallpapers', $_REQUEST) == false || count($_REQUEST['wallpapers']) == 0)
			Functions::AdminError("You must select at least one wallpaper to delete.");

		// Retrieve wallpaper ids from posted array, sort in to string. Easier to re-post.
		$Delete = null;
		foreach($_REQUEST['wallpapers'] as $id)
			$Delete	.= addslashes($id)."|";
				
		// Build output data
		$Content = Functions::LoadTemplate("delete_confirmation", array('walls' => $Delete));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=wallpapers&do=confirm_delete', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation'));
		$HTML = Functions::BuildSection('Delete Confirmation', $Content);

		return $HTML;

	}

	//---------------------------------------------------------------
	// Confirm delete
	// We DEFINATELY want to delete the wallpaper. So let's do it.
	//---------------------------------------------------------------

	function confirm_delete()
	{
		Functions::DemoCheck();

		// Did we enter a wallpaper to delete?
		if ($this->class->main->Data("wallpapers") == null)
			Functions::AdminError("You must select some wallpapers to delete.");

		// Sort wallpapers in to array.
		$Wallpapers = explode("|",$this->class->main->Data("wallpapers"));
		
		// Go through wallpapers we want to delete.
		foreach($Wallpapers as $id)
		{
			if ($id != null)
			{
				// Retrieve the wallpaper details
				$Query = "SELECT * FROM `wallpapers` WHERE `id`=".$id;
				$Result = $this->class->main->mysql->Query($Query);
				$Wallpaper = $this->class->main->mysql->FetchResults($Result);
				$Wallpaper=$Wallpaper[0];

				// Path is for root directory, not /admin/ - let's back it up one.
				$Wallpaper['thumbSmall'] = "../" . $Wallpaper['thumbSmall'];
				$Wallpaper['thumbSmall'] = "../" . $Wallpaper['thumbLarge'];

				// Let's delete the specified wallpaper.
				$this->delete_wallpaper($Wallpaper,false);
			}
		}
	
		// All wallpapers deleted. Let's redirect.
		Functions::Redirect('Your wallpapers have been deleted', 'index.php?act=wallpapers&do=manage');

	}

	//---------------------------------------------------------
    // Name:    delete_wallpaper()
    // Desc:    Process the deletion of a wallpaper.
    //---------------------------------------------------------

	function delete_wallpaper($Wallpaper)
	{
		Functions::DemoCheck();

		// Remove from the wallpapers table
		$Query = "DELETE FROM `wallpapers` WHERE `id`=".$Wallpaper['id'];
		$this->class->main->mysql->Query($Query);

		// Do we need to remove the images?
		if($this->class->main->Data("delete_images") == "on")
		{
			// Remove the thumbnails
			if (file_exists($Wallpaper['thumbSmall']))
				unlink($Wallpaper['thumbSmall']);
			if (file_exists($Wallpaper['thumbLarge']))
				unlink($Wallpaper['thumbLarge']);

			// Retrieve wallpaper uploads.
			$Query = "SELECT * FROM `wallpaper_uploads` WHERE `wid`=".$Wallpaper['id'];
			$Result = $this->class->main->mysql->Query($Query);
			$Uploads = $this->class->main->mysql->FetchResults($Result);

			// Delete the images
			foreach($Uploads as $Upload)
			{
				$Upload['url'] = "../" . $Upload['url'];
				if(file_exists($Upload['url']))
					unlink($Upload['url']);			
			}
		}

		// Delete the rows in the upload table
		$Query = "DELETE * FROM `wallpaper_uploads` WHERE `wid`=".$Wallpaper['id'];

	}

	//---------------------------------------------------------
    // Name:    categories()
    // Desc:    Output the categories
    //---------------------------------------------------------

	function categories()
	{

		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_cat_table_start", array());

		$Structure = Functions::GrabCategories();
		
		foreach($Structure as $ID => $Cat)
		{
			$tbl .= Functions::LoadTemplate("wrapper_cat_entry", array(
					'id'		=> $ID,
					'cat'		=> $Cat['name'],
			));

			// Do we have subcategories?
			if(count($Cat['Sub']) > 0)
			{
				foreach($Cat['Sub'] as $id => $Name)
				{
					$tbl .= Functions::LoadTemplate("wrapper_subcat_entry", array(
							'id'		=> $id,
							'cat'		=> $Name,
					));
				}
			}

		}

		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("table_cats_options", array());

		// Wrap it up in a form
		$form = Functions::LoadTemplate("form", array('action' => '?act=wallpapers&do=delete_cats', 'method' => 'post', 'id' => 'cats_form', 'content' => $tbl));

		// Build it from the template
		$Section = Functions::BuildSection("Categories", $form, array('table' => 1));

		return $Section;

	}

	//---------------------------------------------------------
    // Name:    delete_cats()
    // Desc:    Show confirmation screen. Do we really want to delete?
    //---------------------------------------------------------

	function delete_cats()
	{

		// Are we deleting a single category? (i.e. did we click the delete icon)
		if (array_key_exists('id', $_REQUEST) != false && count($_REQUEST['id']) != 0)
			$_REQUEST['categories'][0] = $_REQUEST['id'];

		// Are we deleting multiple categories?
		if (array_key_exists('categories', $_REQUEST) == false || count($_REQUEST['categories']) == 0)
			Functions::AdminError("You must select at least one category to delete.");

		// Retrieve wallpaper ids from posted array, sort in to string. Easier to re-post.
		$Delete = null;
		foreach($_REQUEST['categories'] as $id)
			$Delete	.= addslashes($id)."|";
				
		// Build output data
		$Content = Functions::LoadTemplate("delete_cat_confirmation", array('walls' => $Delete));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=wallpapers&do=confirm_delete_cats', 'class' => 'search_form general_form', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation'));
		$HTML = Functions::BuildSection('Delete Confirmation', $Content);

		return $HTML;

	}

	//---------------------------------------------------------
    // Name:    new_cat()
    // Desc:    Show form to create a new category.
    //---------------------------------------------------------

	function new_cat()
	{
		// Grab the categories
		$Categories = Functions::CategoriesOptions(false);

		// Build output data
		$Content = Functions::LoadTemplate("new_cat", array('cats' => $Categories));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=wallpapers&do=create_cat', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation', 'class' => 'search_form general_form'));
		$HTML = Functions::BuildSection('Add New Category', $Content);

		return $HTML;
	}

	//---------------------------------------------------------
    // Name:    edit_cat_submit()
    // Desc:    Submit form to edit the wallpaper.
    //---------------------------------------------------------

	function edit_cat_submit()
	{
		Functions::DemoCheck();

		// Some basic checks
		if($this->class->main->Data("id") == null)
			Functions::AdminError("You must enter a category ID.");

		if(! is_numeric($this->class->main->Data("id")))
			Functions::AdminError("Invalid category id entered.");

		if($this->class->main->Data("name") == null)
			Functions::AdminError("You must enter a category name.");

		if($this->class->main->Data("desc") == null)
			Functions::AdminError("You must enter a description.");

		if(strlen($this->class->main->Data("desc")) > 500)
			Functions::AdminError("Description must not be greater than 500 characters.");

		if(!is_numeric($this->class->main->Data("parent")))
			Functions::AdminError("Invalid category parent entered.");

		// No errors thus far, lets see if the parent even exists.
		if($this->class->main->Data("parent") != '0')
		{
			$Query = "SELECT COUNT(*) AS `total`, `id` FROM `categories` WHERE `id` = " . $this->class->main->Data("parent");
			$Result = $this->class->main->mysql->Query($Query);
			$Cat = $this->class->main->mysql->FetchResults($Result);
			$Count = $Cat[0]['total'];

			if($Count == 0)
				Functions::AdminError("That category does not exist.");
		}

		// Is parent same as cat?
		if($this->class->main->Data("parent") == $this->class->main->Data("id"))
			Functions::AdminError("Invalid parent ID.");

		// Grab the category
		$Query = "SELECT * FROM `categories` WHERE `id` = " . $this->class->main->Data("id");
		$Result = $this->class->main->mysql->Query($Query);
		$Category = $this->class->main->mysql->FetchResults($Result);

		// Does it even exist?
		if(count($Category) == 0)
			Functions::AdminError("That category does not exist.");

		$Category = $Category[0];
		$Parent = intval($this->class->main->Data("parent"));

		// All in order, let's update.
		$Query = "UPDATE `categories` SET `name` = '" . $this->class->main->Data("name") . "', `desc` = '" . $this->class->main->Data("desc") . "', `parent` = " . $Parent . " WHERE `id` = " . $this->class->main->Data("id");
		$Result = $this->class->main->mysql->Query($Query);

		// No errors, lets redirect.
		Functions::Redirect( "Category '" . $this->class->main->Data("name") . "' has been edited.", 'index.php?act=wallpapers&do=categories' );

	}

	//---------------------------------------------------------
    // Name:    edit_cat()
    // Desc:	Show form to edit a category.
    //---------------------------------------------------------

	function edit_cat()
	{
		// Some basic checks
		if($this->class->main->Data("id") == null)
			Functions::AdminError("You must enter a category ID.");

		if(! is_numeric($this->class->main->Data("id")))
			Functions::AdminError("Invalid category id entered.");

		// Grab the category
		$Query = "SELECT * FROM `categories` WHERE `id` = " . $this->class->main->Data("id");
		$Result = $this->class->main->mysql->Query($Query);
		$Category = $this->class->main->mysql->FetchResults($Result);

		// Does it even exist?
		if(count($Category) == 0)
			Functions::AdminError("That category does not exist.");

		$Category = $Category[0];

		// Grab the categories
		$Categories = Functions::GrabCategories();
		
		// Go through the categories
		$Options = null;
		foreach($Categories as $id => $Cat)
		{
			// If not current category (can't be its own parent)
			if($id != $this->class->main->Data("id"))
			{
				// Category parent?
				$Extra = ($id == $Category['parent']) ? ' selected' : null;

				// Output option
				$Options .= "<option value='".$id."'" . $Extra . ">".$Cat['name']."</option>\n";
			}
		}

		// Build output data
		$Content = Functions::LoadTemplate("edit_cat", array('cats' => $Options, 'name' => $Category['name'], 'desc' => $Category['desc']));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=wallpapers&do=edit_cat_submit&id=' . $Category['id'], 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation', 'class' => 'search_form general_form'));
		$HTML = Functions::BuildSection('Edit Category', $Content);

		return $HTML;
	}

	//---------------------------------------------------------
    // Name:    create_cat()
    // Desc:    Process the creation of the category
    //---------------------------------------------------------

	function create_cat()
	{
		Functions::DemoCheck();

		// Some basic security checks
		
		if($this->class->main->Data("name") == null)
			Functions::AdminError("You must enter a category name.");

		if($this->class->main->Data("desc") == null)
			Functions::AdminError("You must enter a description.");

		if(strlen($this->class->main->Data("desc")) > 500)
			Functions::AdminError("Description must not be greater than 500 characters.");

		if(!is_numeric($this->class->main->Data("parent")))
			Functions::AdminError("Invalid category parent entered.");

		// No errors thus far, lets see if the parent even exists.
		if($this->class->main->Data("parent") != '0')
		{
			$Query = "SELECT COUNT(*) AS `total` FROM `categories` WHERE `id` = " . $this->class->main->Data("parent");
			$Result = $this->class->main->mysql->Query($Query);
			$Count = $this->class->main->mysql->FetchResults($Result);
			$Count = $Count[0]['total'];

			if($Count == 0)
				Functions::AdminError("That category does not exist.");
		}

		// No more errors, let's create the category.
		$Query = "INSERT INTO `categories` (`name`, `desc`, `parent`) VALUES('" . $this->class->main->Data("name") . "', '" . $this->class->main->Data("desc") . "', " . intval($this->class->main->Data("parent")) . ")";
		$Result = $this->class->main->mysql->Query($Query);

		// No errors, lets redirect.
		Functions::Redirect( "Category '" . $this->class->main->Data("name") . "' has been created.", 'index.php?act=wallpapers&do=categories' );

	}

	//---------------------------------------------------------
    // Name:    confirm_delete_cats()
    // Desc:    Confirm deletion of categories
    //---------------------------------------------------------

	function confirm_delete_cats()
	{
		Functions::DemoCheck();

		// 'Explode' in to an array.
		$Categories = explode("|", $this->class->main->Data("categories"));
		
		// Loop through the categories
		foreach($Categories as $Category)
		{
			// Is it a valid category?
			if(!is_null($Category) && intval($Category) > 0)
			{
				$Delete = array();

				// Retrieve category details
				$Query = "SELECT * FROM `categories` WHERE `id` = ". $Category;
				$Result = $this->class->main->mysql->Query($Query);
				$Cat = $this->class->main->mysql->FetchResults($Result);
				$Cat = $Cat[0];
				
				if(!in_array($Cat['id'], $Delete))
					$Delete[] = $Cat['id'];

				// Is it a main category (i.e. not a sub)
				if($Cat['parent'] == '0')
				{
					// Fetch child categories
					$Query = "SELECT * FROM `categories` WHERE `parent` = " . $Category;
					$Result = $this->class->main->mysql->Query($Query);
					$Subs = $this->class->main->mysql->FetchResults($Result);
					foreach($Subs as $Val)
						$Delete[] = $Val['id'];
				}

				// We have all the categories we want to delete, now we have to delete all of the wallpapers in those categories.
				foreach($Delete as $ID)
				{
					if(!is_null($ID) && intval($ID) > 0)
					{
						// Select wallpapers
						$Query = "SELECT `id`, `thumbSmall`, `thumbLarge` FROM `wallpapers` WHERE `cat` = ".$ID;
						$Result = $this->class->main->mysql->Query($Query);
						$Wallpapers = $this->class->main->mysql->FetchResults($Result);

						// Are there any wallpapers to delete?
						if(count($Wallpapers) > 0)
						{
							// Go through the wallpapers
							foreach($Wallpapers as $Wallpaper)
							{

								// Delete the thumbnails
								unlink( '../' . $Wallpaper['thumbSmall'] );
								unlink( '../' . $Wallpaper['thumbLarge'] );

								// Delete the uploads
								$Query = "SELECT `url` FROM `wallpaper_uploads` WHERE `wid` = " . $Wallpaper['id'];
								$Result = $this->class->main->mysql->Query($Query);
								$Uploads =  $this->class->main->mysql->FetchResults($Result);
								
								// There are uploads to delete
								if(count($Uploads) > 0)
								{
									foreach($Uploads as $Upload)
										unlink( '../' . $Upload['url'] );
									
									//  Delete the uploads
									$Query = "DELETE FROM `wallpaper_uploads` WHERE `wid` = " . $Wallpaper['id'];
									$Result = $this->class->main->mysql->Query($Query);
								}

								//  Delete the wallpaper
								$Query = "DELETE FROM `wallpapers` WHERE `id` = " . $Wallpaper['id'];
								$Result = $this->class->main->mysql->Query($Query);
							}
						}

						// Delete the category
						"DELETE FROM suppliers WHERE EXISTS (SELECT FROM `categories` WHERE `id` = " . $ID . ")";
						$Query = "DELETE FROM `categories` WHERE `id` = " . $ID;
						$Result = $this->class->main->mysql->Query($Query);
					}
				}
			}
		}

		Functions::Redirect( 'Selected categories have been deleted.', 'index.php?act=wallpapers&do=categories' );

	}


	//---------------------------------------------------------
    // Name:    bulk()
    // Desc:    Let's bulk upload those wallpapers
    //---------------------------------------------------------

	function bulk()
	{
		//---------------------------------------
		// Are we outputting?
		//---------------------------------------

		// Get the folders
		$dir = "../bulk/";
		$r = array();

		if (is_dir($dir))
		{
			if($d_handle = opendir($dir))
			{
				while (($file = readdir($d_handle)) !== false) 
					if(!in_array($file, array(".", "..")) && strtolower(filetype($dir . $file)) == 'dir')
						$r[] = $file;
				closedir($d_handle);
			} 
		}

		//---------------------------------------
		// Configure the auto adjusting height
		//---------------------------------------

		$Amount = count($r);
		$Amount = $Amount > 7 ? 7 : $Amount;

		$Height = $Amount * 20 + 15;
		if($Height <= 30) $Height = 35;

		//---------------------------------------
		// Are we outputting?
		//---------------------------------------

		$do = $this->class->main->Data("a");

		if($do == 'output')
		{
			// HTML contained in iframe
			echo "<div style='font-size:12px; font-family: arial;'>\n";
			if(count($r) == 0)
				echo 'No folders found in bulk upload directory.';
			else
				foreach($r as $folder)
					echo '<input class="radio" id="folders[]" name="folders[]" value=" ' .$folder . '" type="checkbox" /> ' . $folder . "<br />\n";
			
			echo "</div>";
			
			exit;
		}

		//---------------------------------------
		// Pending bulk uploads
		//---------------------------------------

		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_bulk_table_start", array());

		$Query = "SELECT * FROM `admin_bulk` WHERE `end` = 0";
		$Result = $this->class->main->mysql->Query($Query);
		$Bulks = $this->class->main->mysql->FetchResults($Result);

		// Do we have any pending bulk uploads?
		$User = array();

		// Variables
		$Section = null;

		if(count($Bulks) > 0)
		{
			foreach($Bulks as $ID => $Bulk)
			{
				// Parse folders
				$Folders = str_replace('|_|_|', ',', $Bulk['folders']);
				$Folders = substr($Folders, 0, strlen($Folders) - 1);

				// Figure out the time started
				$Hours = intval(date("G"));
				$Minutes = intval(date("i"));
				$Seconds = intval(date("s"));

				// How long ago did we start?
				$Started = $Bulk['start'];
				$Difference = time() - $Started;

				// How many seconds have passed since the start of the day
				$Passed = ($Hours * 3600) + ($Minutes * 60) + $Seconds;

				// Did we start at least a day ago?
				$Start = ($Difference > $Passed) ? 'm/d/Y g:ia' : 'g:ia';
				$Start = date($Start, $Started);

				// Time of last update
				if($Bulk['last_update'] == '0')
				{
					$file = $Difference > 90 ? 'images/small_red_loading.png' : 'images/small_loading.png';
					$Update = 'n/a';
				} else
				{
					// How long ago did we start?
					$LastUpdate = $Bulk['last_update'];
					$Difference = time() - $LastUpdate;

					// Did we start at least a day ago?
					$Update = ($Difference > $Passed) ? 'm/d/Y g:ia' : 'g:ia';
					$Update = date($Update, $LastUpdate);

					// Percentage loading bar
					$file = ($Difference > 90) ? 'images/small_red_loading.png' : 'images/small_loading.png';
				}

				// Percentage HTML
				$Percentage = $Bulk['complete'];
				$Loading = Functions::LoadTemplate("loading_bar", array(
					'width_left'		=> $Percentage * 2,
					'width_right'		=> (100 - $Percentage) * 2,
					'image'				=> $file,
					'height'			=> 15,
					'bg'				=> 'FFF',
				));


				// Select the user
				if( ! array_key_exists($Bulk['admin'], $User) )
				{
					$Query = "SELECT `username` FROM `users` WHERE `userid` = ". $Bulk['admin'];
					$Result = $this->class->main->mysql->Query($Query);
					$Admin = $this->class->main->mysql->FetchResults($Result);
					$User[$Bulk['admin']] = $Admin[0]['username'];
				}

				$tbl .= Functions::LoadTemplate("wrapper_bulk_entry", array(
					'id'			=> $Bulk['id'],
					'folder'		=> $Folders,
					'perc'			=> $Loading,
					'start'			=> $Start,
					'last_update'	=> $Update,
					'admin'			=> $User[$Bulk['admin']],
				));
			}

			// Finish up the table
			$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
			$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
			$tbl .= Functions::LoadTemplate("table_bulk_options", array());

			// Wrap it up in a form
			$form = Functions::LoadTemplate("form", array('action' => '?act=wallpapers&do=delete_bulk', 'method' => 'post', 'id' => 'cats_form', 'content' => $tbl));

			// Build it from the template
			$Section = Functions::BuildSection("Pending Bulk Uploads", $form, array('table' => 1));
		}

		//---------------------------------------
		// Not outputting, display the form
		//---------------------------------------		

		// Grab the categories
		$Cats = Functions::CategoriesOptions();

		// Form template
		$HTML = Functions::LoadTemplate("bulk_form", array('Cats' => $Cats, 'height' => $Height));
		$HTML = $Section . Functions::BuildSection('Bulk Upload', $HTML);

		return $HTML;

	}
	//---------------------------------------------------------
    // Name:    submit_bulk()
    // Desc:    Functions that processes the bulk submitted form.
    //---------------------------------------------------------

	function submit_bulk()
	{
		Functions::DemoCheck();
		
		//---------------------------------------
		// Retrieve POSTED variables
		//---------------------------------------
	
		$Category = intval($this->class->main->Data("category"));
		$Name = intval($this->class->main->Data("name"));
		$Resize = intval($this->class->main->Data("resize"));
		$Special = intval($this->class->main->Data("special"));
		$Numbers = intval($this->class->main->Data("numbers"));
		$Suffix = intval($this->class->main->Data("ordered_suffix"));
		$Delete = intval($this->class->main->Data("delete"));
		$Capitilize = intval($this->class->main->Data("capitilize"));

		// Did we select a folder?
		$Folders = $_REQUEST['folders'];
		if(!is_array($Folders) || count($Folders) == 0)
			Functions::AdminError("You must select a folder to upload.");
	
		// Format folders in to string
		$Fold = null;
		foreach($Folders as $Folder)
			$Fold .= mysql_real_escape_string($Folder)."|_|_|";

		// Generate unique id (used to grab row from database)
		$UniqId = uniqid();

		// Insert session in to database.
		$Query = "INSERT INTO `admin_bulk` (`folders`, `admin`, `cat`, `names`, `resize`, `special`, `rand`, `complete`, `start`, `numbers`, `ordered`, `delete`, `capitalize`) VALUES('" . $Fold . "', " . $this->class->Admin['userid'] . ", '" . $Category . "', '" . $Name . "', '" . $Resize . "', '" . $Special . "', '" . $UniqId . "', 1, " . time() . ", " . $Numbers . ", " . $Suffix . ", " . $Delete . ", " . $Capitilize . ")";
		$Result = $this->class->main->mysql->Query($Query);

		// Output status/execute bulk.
		$HTML = Functions::LoadTemplate("bulk_status", array('UniqId' => $UniqId));
		#$HTML .= "<br /><iframe src='index.php?act=wallpapers&do=start_bulk&id={$UniqId}' style='width:800px; height:400px; display: block;'></iframe>";
		$HTML .= "<br /><iframe src='index.php?act=wallpapers&do=start_bulk&id={$UniqId}' style='width:1px; height:1px; display: none;'></iframe>";

		$HTML = Functions::BuildSection('Bulk Upload', $HTML);

		session_destroy();

		return $HTML;

	}

	//---------------------------------------------------------
    // Name:    start_bulk()
    // Desc:    Let's bulk upload those wallpapers
    //---------------------------------------------------------

	function start_bulk()
	{
		Functions::DemoCheck();

		// Debug
		echo "<pre>";

		// Run for four hours
		set_time_limit(14400);

		// Grab ID from URL
		$Id = $this->class->main->Data("id");

		// Select the bulk session from the database
		$Query = "SELECT * FROM `admin_bulk` WHERE `rand` = '" . $Id . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$Bulk = $this->class->main->mysql->FetchResults($Result);
		$Bulk = $Bulk[0];

		//---------------------------------------
		// Sort the folders in to an array
		//---------------------------------------

		$tmp = $Bulk['folders'];
		$tmp = explode("|_|_|", $tmp);

		$Folders = array();
		$Total = array();

		// Loop through the folders
		foreach($tmp as $Folder)
		{
			// Do we have a valid folder?
			if(! is_null($Folder) && $Folder != null)
			{
				if(substr($Folder, 0, 1) == " ")
					$Folder = substr($Folder, -(strlen($Folder)-1));

				if(!is_null($Folder) && $Folder != null)
					$Folders[] = $Folder;

				// Get the files in the folder (needed to find total files for percentage)
				$tmp = Functions::FolderImages("../bulk/" . $Folder);
				$Total = array_merge($Total, $tmp);
			}
		}

		// Total files we're going to upload.
		$Total = count($Total);

		//---------------------------------------
		// Sort out the dimensions
		//---------------------------------------

		// Grab dimensions from database
		$Dimensions = $this->class->main->Settings['dimensions'];

		// Explode in to array
		$tmpDim = explode("|",$Dimensions);
		$wDimensions = array();

		// Suffix
		$Suffix = 1;

		// Find aspect ratio of each dimension, do we really want to do it?
		foreach($tmpDim as $val) 
		{
			$tmpDimTwo = explode("x",$val);
			$wDimensions[] = array("width" => $tmpDimTwo[0], "height" => $tmpDimTwo[1], "ratio" => Functions::Ratio($tmpDimTwo[0], $tmpDimTwo[1]));
		}	

		// Max amount of pixels (squared) in an image (too large can result in a memory error)
		$Max = 3300 * 3300;

		//---------------------------------------
		// Let's upload the wallpapers
		//---------------------------------------

		// Amount of wallpapers uploaded (used for status)
		$Done = 0;	

		// Loop through each of the folders we want to upload from.
		foreach($Folders as $Folder)
		{
		
			// Folder images
			$tmp = Functions::FolderImages("../bulk/" . $Folder);

			// Loop through the files in each folder
			foreach($tmp as $File)
			{	
				//-----------------------------------------------------------
				// Upload the thumbnails (large and small)
				//-----------------------------------------------------------

				$Wallpaper = array();

				// Use file name
				if($Bulk['names'] == '1')
				{
					$Name = str_ireplace(array(".jpg", ".gif", ".png", ".jpeg", ".x-png", "bmp"), null, $File);
					$Name = substr($Name, strrpos($Name, "/") + 1, strlen($Name) - 1);
				} else $Name = $Folder;

				// Are we stripping special characters from the name?
				if($Bulk['special'] == '1')
					$Name = Functions::strip_chars($Name);
				
				// Are we stripping the numbers?
				if($Bulk['numbers'] == '1')
					$Name = preg_replace("/\d/", null, $Name);

				// Capitalizing first letter of each word?
				if($Bulk['capitalize'] == '1')
					$Name = ucwords(strtolower($Name));

				$Name = str_replace(array("'"), null, $Name);

				// If the name is not valid (i.e. no characters), then skip.
				if( strlen( $Name ) == 0 ) $Name = "Wallpaper";

				// Need to grab the tags now
				$Wallpaper['tags'] = str_replace(' ', ',', strtolower($Name));
				$Wallpaper['tags'] = str_replace(array("'"), null, $Wallpaper['tags']);

				// Do we want an ordered suffix?
				if($Bulk['ordered'] == '1') $Name .= " " . $Suffix;

				// Sort wallpaper details in to array.
				$Wallpaper['name'] = $Name;
				$Wallpaper['escape_name'] = str_replace("'", null, $Wallpaper['name']);
				$Wallpaper['escape_name'] = str_replace('+', '_', urlencode($Wallpaper['escape_name']));
				$Wallpaper['extension'] = substr($File, strrpos($File,'.'));
				$Wallpaper['file'] = "thumbnails/";

				// Wallpaper width and height.
				list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($File);
				$Width = $Wallpaper['width'];
				$Height = $Wallpaper['height'];	
				
				// Aspect ratio of the wallpaper.
				$Ratio = Functions::Ratio($Wallpaper['width'], $Wallpaper['height']);

				// Let's sort out the wallpaper dimensions
				$Sizes = array();
				foreach($wDimensions as $Dime) 
					if ($Dime['width'] != $Wallpaper['width'] && $Dime['height'] != $Wallpaper['height']) // Different wallpaper
						if($Dime['ratio'] == $Ratio && intval($Dime['width']) < intval($Width) && intval($Dime['height']) < intval($Height)) // Same ratio, we can use it.
							$Sizes[] = $Dime['width']."x".$Dime['height'];
			
				// Large thumbnail width/height settings.
				$resizeRatio = $Wallpaper['width'] / 488;
				$Width = 488;
				$Height = round($Wallpaper['height'] / $resizeRatio,0);

				// Is the file too large?
				if(intval($Wallpaper['height']) * intval($Wallpaper['width']) < $Max)
				{
					// Increment suffix
					$Suffix++;

					// Large thumbnail
					$ThumbLarge = $Wallpaper['file'] . "large_".$Wallpaper['escape_name']."_".rand(1,100000).$Wallpaper['extension'];
					Functions::resizeImage($File, '../' . $ThumbLarge, $Width, $Height);

					// Small thumbnail
					$ThumbSmall = $Wallpaper['file'].$Wallpaper['escape_name']."_".rand(10000,100000).$Wallpaper['extension'];
					Functions::resizeImage($File, '../' . $ThumbSmall, 160, 120); // Revision: stick with 160x120

					//-----------------------------------------------------------
					// Add to the database
					//-----------------------------------------------------------

					$User = $this->class->Admin['username'];

					$Query = "INSERT INTO `wallpapers` (`cat`,`name`,`desc`,`thumbSmall`,`thumbLarge`,`tags`,`time`,`author`,`status`) VALUES(".
							"'".$Bulk['cat']."','".addslashes($Wallpaper['name'])."','".addslashes($Wallpaper['name'])."','".$ThumbSmall."','".$ThumbLarge."','".addslashes($Wallpaper['tags'])."',".
							"'".time()."','".$User."', 1)";

					$this->class->main->mysql->Query($Query);

					// Fetch the id
					$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
					$res = $this->class->main->mysql->Query($Query);
					$id = $this->class->main->mysql->FetchResults($res);
					$id = $id[0]['id'];

					//-----------------------------------------------------------
					// Move the temporary file
					//-----------------------------------------------------------

					$wallFile = "wallpapers/".$Wallpaper['escape_name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
					Functions::resizeImage($File, '../' . $wallFile, $Wallpaper['width'], $Wallpaper['height']);

					$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
							"VALUES('".$id."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
					$this->class->main->mysql->Query($Query);

					//-----------------------------------------------------------
					// Move all of the files
					//-----------------------------------------------------------

					if (count($Sizes) > 0)
					{
						foreach($Sizes as $ide => $val)
						{
							// Are we resizing the wallpaper?
							if ($Bulk['resize'] == '1') 
							{
								// Width and height to resize to.
								$tmp = explode("x",$val);
								$Width = $tmp[0];
								$Height = $tmp[1];

								// Physically resize wallpaper and move to proper directory.
								$wallFile = "wallpapers/".$Wallpaper['escape_name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
								Functions::resizeImage($File, '../' . $wallFile, $Width, $Height);

								// Insert resized wallpaper in to the database.
								$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
										"VALUES('".$id."','".$Width."','".$Height."','".$wallFile."')";
								$this->class->main->mysql->Query($Query);
							}
						}
					}

					// Just another wallpaper processed.
					$Done++;

					// Finished it for this wallpaper
					$Perc = round($Done / $Total * 100);

					// Update the percentage of wallpapers done.
					if($Perc == 100)
						$Query = "UPDATE `admin_bulk` SET `complete` = '100', `end` = '" . time() . "', `last_update` = " . time() . " WHERE `id` = " . $Bulk['id'];
					else  $Query = "UPDATE `admin_bulk` SET `complete` = '$Perc', `last_update` = " . time() . " WHERE `id` = ".$Bulk['id'];

					$Result = $this->class->main->mysql->Query($Query);
					
				} else $Done++;
			}

			// Are we deleting the folder?
			if($Bulk['delete'] == '1')
				Functions::delete_directory("../bulk/" . $Folder);
		}

		echo "</pre>";
		exit;
	}

	function delete_bulk()
	{
		Functions::DemoCheck();

		$Bulk = $_POST['bulk'];

		if( is_null($Bulk) || $Bulk == null || count($Bulk) == 0)
			Functions::AdminError("You must select a bulk upload session to delete.");

		foreach($Bulk as $ID)
		{
			$Id = addslashes($ID);
			$Query = "DELETE FROM `admin_bulk` WHERE `id` = $ID";
			$Result = $this->class->main->mysql->Query($Query);
		}

		Functions::Redirect( "Bulk upload sessions have been deleted.", "index.php?act=wallpapers&do=bulk" );
	}

	function add_wallpaper()
	{
		// Grab the categories
		$Categories = Functions::CategoriesOptions();
		
		$HTML = null;
		$HTML .= Functions::LoadTemplate("add_wallpaper", array(
			'Options'		=> $Categories,	
		));

		$HTML = Functions::BuildSection('Upload Wallpaper', $HTML);

		$Page = Functions::LoadTemplate("bulk");
		$Page = Functions::BuildSection('Bulk Upload', $Page);


		return $Page . $HTML;

	}
	
	//---------------------------------------------------------
    // Name:    submit_upload()
    // Desc:    Process the submission of a wallpaper.
    //---------------------------------------------------------

	function submit_upload($skip=false, $path="a")
	{
		Functions::DemoCheck();

		//-----------------------------------------------------------
		// Lets just filter out the content
		//-----------------------------------------------------------

		$Posted = array();
		foreach($_REQUEST as $ide => $val)
			$Posted[$ide] = str_replace('../../', '../', $this->class->main->Data($ide));

		$Dim = array();
		if (array_key_exists('Dimensions', $_REQUEST) && count($_REQUEST['Dimensions']) > 0) 
		{
			foreach($_REQUEST['Dimensions'] as $i => $v)
				$Dim[addslashes($i)] = addslashes($v);
		}

		$Posted['Dimensions'] = $Dim;

		//-----------------------------------------------------------
		// Lets upload it!
		//-----------------------------------------------------------

		if ($Posted['title'] == null)
			Functions::AdminError("You must enter a wallpaper title.");

		if ($Posted['tags'] == null)
			Functions::AdminError("You must enter wallpaper tags.");

		if ($Posted['description'] == null)
			Functions::AdminError("You must enter a wallpaper description.");

		if ($Posted['cat'] == null || !is_numeric($Posted['cat']))
			Functions::AdminError("Invalid category id.");

		//-----------------------------------------------------------
		// Upload the thumbnails (large and small)
		//-----------------------------------------------------------

		$Wallpaper['name'] = preg_replace("/([ ]+)/","_", strtolower($Posted['title']));
		$Wallpaper['extension'] = substr($Posted['path'], strrpos($Posted['path'],'.'));
		$Wallpaper['file'] = "thumbnails/";
		list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($Posted['path']);

		$resizeRatio = $Wallpaper['width'] / 488;
		$Width = 488;
		$Height = round($Wallpaper['height'] / $resizeRatio,0);

		// Large thumbnail
		$ThumbLarge = $Wallpaper['file']."large_".$Wallpaper['name']."_".rand(1,100000).$Wallpaper['extension'];
		Functions::resizeImage($Posted['path'], '../' . $ThumbLarge,$Width,$Height);

		// Small thumbnail
		$ThumbSmall = $Wallpaper['file'].$Wallpaper['name']."_".rand(10000,100000).$Wallpaper['extension'];
		Functions::resizeImage($Posted['path'], '../' . $ThumbSmall,160,120); // Revision: stick with 160x120

		//-----------------------------------------------------------
		// Add to the database
		//-----------------------------------------------------------

		$User =  $this->class->Admin['username'];

		$Query = "INSERT INTO `wallpapers` (`cat`,`name`,`desc`,`thumbSmall`,`thumbLarge`,`tags`,`time`,`author`, `status`) VALUES(".
				"'".$Posted['cat']."','".$Posted['title']."','".$Posted['description']."','".$ThumbSmall."','".$ThumbLarge."','".$Posted['tags']."',".
				"'".time()."','".$User."', 1)";

		$this->class->main->mysql->Query($Query);

		// Fetch the id
		$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
		$res = $this->class->main->mysql->Query($Query);
		$id = $this->class->main->mysql->FetchResults($res);
		$id = $id[0]['id'];

		//-----------------------------------------------------------
		// Move the temporary file
		//-----------------------------------------------------------

		$wallFile = "wallpapers/".$Wallpaper['name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
		Functions::resizeImage($Posted['path'], '../' . $wallFile,$Wallpaper['width'],$Wallpaper['height']);

		$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
				"VALUES('".$id."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
		$this->class->main->mysql->Query($Query);

		//-----------------------------------------------------------
		// Move all of the files
		//-----------------------------------------------------------

		if (count($Posted['Dimensions']) > 0)
		{
			foreach($Posted['Dimensions'] as $ide => $val)
			{
				if ($val == 'on') 
				{
					$tmp = explode("x",$ide);
					$Width = $tmp[0];
					$Height = $tmp[1];

					$wallFile = "wallpapers/".$Wallpaper['name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
					Functions::resizeImage($Posted['path'], '../' . $wallFile,$Width,$Height);

					$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
							"VALUES('".$id."','".$Width."','".$Height."','".$wallFile."')";
					$this->class->main->mysql->Query($Query);
				}
			}
		}

		// Delete the temp file
		unlink($Posted['path']);

		// Wallpaper uploaded, redirect.
		Functions::Redirect('Your wallpaper has been uploaded', 'index.php?act=wallpapers&do=manage');

	}

	function edit_wallpaper()
	{
		if (!is_numeric($this->class->main->Data("id")))
			Functions::AdminError("Wallpaper id is not valid.");

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->main->Data("id")."'";
		$Result = $this->class->main->mysql->Query($Query);
		$Wallpaper = $this->class->main->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];

		if (count($Wallpaper) == 0)
			Functions::AdminError("That wallpaper does not exist.");

		$Options = Functions::CategoriesOptions(true, $Wallpaper['cat']);

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$HTML = Functions::LoadTemplate("wallpaper_edit", array(
			"Options"		=> $Options,
			"min_length"	=> 3,
			"title"			=> $Wallpaper['name'],
			"tags"			=> $Wallpaper['tags'],
			"description"	=> $Wallpaper['desc'],
			"thumb"			=> $Wallpaper['thumbLarge'],
			"id"			=> $Wallpaper['id'],
			"author"		=> $Wallpaper['author'],
		));

		$HTML = Functions::BuildSection( 'Edit Wallpaper', $HTML );

		return $HTML;

	}

	//---------------------------------------------------------
    // Name:    submit_edit()
    // Desc:    What to do when we've submitted the edited wallpaper.
    //---------------------------------------------------------

	function submit_edit()
	{
		Functions::DemoCheck();

		//-----------------------------------------------------------
		// Lets just filter out the content
		//-----------------------------------------------------------

		$Posted = array();
		foreach($_REQUEST as $ide => $val)
			$Posted[$ide] = str_replace(array("'"), null, $this->class->main->Data($ide));

		$Dim = array();
		if (array_key_exists('Dimensions', $_REQUEST) && count($_REQUEST['Dimensions']) > 0) 
		{
			foreach($_REQUEST['Dimensions'] as $i => $v)
				$Dim[addslashes($i)] = addslashes($v);
		}

		$Posted['Dimensions'] = $Dim;

		//-----------------------------------------------------------
		// Perform some basic check
		//-----------------------------------------------------------

		if (!is_numeric($this->class->main->Data("wallid")))
			Functions::AdminError("Wallpaper id is not valid.");

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->main->Data("wallid")."'";
		$Result = $this->class->main->mysql->Query($Query);
		$Wallpaper = $this->class->main->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];

		if (count($Wallpaper) == 0)
			Functions::AdminError("That wallpaper does not exist.");
		
		//-----------------------------------------------------------
		// Lets upload it!
		//-----------------------------------------------------------

		if ($Posted['title'] == null)
			Functions::AdminError("You must enter a wallpaper title.");

		if ($Posted['tags'] == null)
			Functions::AdminError("You must enter wallpaper tags.");

		if ($Posted['description'] == null)
			Functions::AdminError("You must enter a wallpaper description.");

		if ($Posted['cat'] == null || !is_numeric($Posted['cat']))
			Functions::AdminError("Invalid category id.");

		//-----------------------------------------------------------
		// Upload the thumbnails (large and small)
		//-----------------------------------------------------------


		if ($this->class->main->Data("path") != null)
		{

			$Wallpaper['name'] = preg_replace("/([ ]+)/","_", strtolower($Posted['title']));
			$Wallpaper['extension'] = substr($Posted['path'], strrpos($Posted['path'],'.'));
			$Wallpaper['file'] = "thumbnails/";

			$Posted['path'] = str_replace("../../", "../", $Posted['path']);

			list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($Posted['path']);

			$resizeRatio = $Wallpaper['width'] / 488;
			$Width = 488;
			$Height = round($Wallpaper['height'] / $resizeRatio,0);

			// Large thumbnail
			$ThumbLarge = $Wallpaper['file']."large_".$Wallpaper['name']."_".rand(1,100000).$Wallpaper['extension'];

			functions::resizeImage($Posted['path'], '../' . $ThumbLarge,$Width,$Height);

			// Small thumbnail
			$ThumbSmall = $Wallpaper['file'].$Wallpaper['name']."_".rand(10000,100000).$Wallpaper['extension'];
			functions::resizeImage($Posted['path'], '../' . $ThumbSmall,160,120); // Revision: stick with 160x120

			//-----------------------------------------------------------
			// Add to the database
			//-----------------------------------------------------------

			$Query = "UPDATE `wallpapers` SET `thumbSmall`='".$ThumbSmall."', `thumbLarge`='".$ThumbLarge."' WHERE `id`='".$Posted['wallid']."'";
			$this->class->main->mysql->Query($Query);

			// Fetch the id
			$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
			$res = $this->class->main->mysql->Query($Query);
			$id = $this->class->main->mysql->FetchResults($res);
			$id = $id[0]['id'];

			//-----------------------------------------------------------
			// Move the temporary file
			//-----------------------------------------------------------

			$wallFile = "wallpapers/".$Wallpaper['name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
			functions::resizeImage($Posted['path'], '../' . $wallFile,$Wallpaper['width'],$Wallpaper['height']);

			$Query = "DELETE FROM `wallpaper_uploads` WHERE `wid`='".$Posted['wallid']."'";
			$this->class->main->mysql->Query($Query);

			$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
					"VALUES('".$Posted['wallid']."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
			$this->class->main->mysql->Query($Query);

			//-----------------------------------------------------------
			// Move all of the files
			//-----------------------------------------------------------

			if (count($Posted['Dimensions']) > 0)
			{
				foreach($Posted['Dimensions'] as $ide => $val)
				{
					if ($val == 'on') 
					{
						$tmp = explode("x",$ide);
						$Width = $tmp[0];
						$Height = $tmp[1];

						$wallFile = "wallpapers/".$Wallpaper['name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
						functions::resizeImage($Posted['path'], '../' . $wallFile,$Width,$Height);

						$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
								"VALUES('".$Posted['wallid']."','".$Width."','".$Height."','".$wallFile."')";
						$this->class->main->mysql->Query($Query);
					}
				}
			}
		}
		
		// Update
		$Query = "UPDATE `wallpapers` SET `name`='".$Posted['title']."', `desc`='".$Posted['description']."', `cat`=".$Posted['cat'].", `tags`='".$Posted['tags']."', `author` = '" . $Posted['author'] . "' WHERE `id`=".$Posted['wallid'];
		$Result = $this->class->main->mysql->Query($Query);
		
		//  All done
		Functions::Redirect( 'Your wallpaper has been edited', 'index.php?act=wallpapers&do=manage' );
			
	}

	function watermark()
	{
		// Get the folders
		$dir = "../etc/fonts/";
		$r = array();
		if (is_dir($dir))
		{
			if($d_handle = opendir($dir))
			{
				while (($file = readdir($d_handle)) !== false) 
					if(!in_array($file, array(".", "..")) && strtolower(filetype($dir . $file)) == 'file' && strtolower(substr($file, strrpos($file, '.')+1, strlen($file))) == 'ttf')
						$r[] = $file;
				closedir($d_handle);
			} 
		}

		//---------------------------------------
		// Are we outputting?
		//---------------------------------------

		$do = $this->class->main->Data("a");

		if($do == 'output')
		{
			// HTML contained in iframe
			echo "<div style='font-size:12px; font-family: arial;'>\n";
			if(count($r) == 0)
				echo 'No fonts found in: ' . $dir;
			else
			{
				foreach($r as $id => $folder)
				{
					$folder = str_replace(' ', null, $folder);
					$this->class->main->Settings['watermark_font'] = str_replace(' ', null, $this->class->main->Settings['watermark_font']);
					$Ext = strtolower($folder) == strtolower($this->class->main->Settings['watermark_font']) ? ' checked' : null;
					echo '<input class="radio" id="font[]" name="font[]" value=" ' .$folder . '" type="radio"' . $Ext . ' /> ' . $folder . "<br />\n";
				}
			}
			echo "</div>";
			
			exit;
		}

		$HTML = Functions::LoadTemplate( "watermark", $this->class->main->Settings );
		$HTML = Functions::BuildSection( "Watermark Settings", $HTML);

		$Content = Functions::LoadTemplate("form", array("action" => '?act=wallpapers&do=submit_watermark', 'method' => 'post', 'content' => $HTML, 'id' => '', 'class' => 'search_form general_form'));
		return $Content;
	}

	function Update($Redirect = '?act=main&do=seo', $Message = 'Your settings have been updated.')
	{
		Functions::DemoCheck();

		$Queries = array();
		foreach($_POST as $Name => $Val)
		{
			// Only run query if it's changed.
			if($this->class->main->Settings[$Name] != $Val)
				$Queries[] = "UPDATE `settings` SET `value` = '" . $this->class->main->Data($Name) . "' WHERE `identifier` = '" . addslashes($Name) . "'";
		}

		foreach($Queries as $Query)
			$this->class->main->mysql->Query($Query);

		Functions::Redirect($Message , $Redirect);
	}

	function submit_watermark()
	{
		Functions::DemoCheck();

		// Update last watermark edit
		$this->class->main->mysql->Query("UPDATE `settings` SET `value` = " . time() . " WHERE `identifier` = 'watermark_last_edit'");

		$this->Update('?act=wallpapers&do=watermark');
	}


}

?>