<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Plugins
|   > Script written by Alex Roxon
|   > Date started: Apr 11 2009
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/


class Comment
{
	var $class;
	var $functions;

	var $timeBetween = 15; // Min time between comments in seconds.
	var $timeBetweenReports = 10; // Min time between each report. 
	var $CommentsPerPage = 5; // Comments per page
	var $commentSunk = -3; // Rating for a comment to be classified as "sunk"
	var $comMessage = "You have received a comment on wallpaper [url='../cat/wallpaper-&&wid&&.html']&&wallpaper&&[/url].";
	var $comTitle = "Comment Received";

	var $return = array();

	//----------------------------------------------------------
	// Name:	run()
	// Desc:	Main function which handles the class
	//----------------------------------------------------------

	function run()
	{

		switch($this->class->Data("mode"))
		{
			case "report":
				return $this->report();
				break;
			case "load":
				return $this->LoadComment();
				break;
			case "rate":
				return $this->rate();
				break;
		}

		//---------------------------------------
		// Retrieve the variables and verify input
		//---------------------------------------

		if ($this->class->Data("wid") == null || !is_numeric($this->class->Data("wid")))
		{
			die($this->class->lang->Phrase['inv_wid']);
		}

		if($this->class->Data("c") == null)
		{
			die($this->class->lang->Phrase['empt_comment']);
		}

		//---------------------------------------
		// Put the two values into a local variable
		//---------------------------------------

		$Comment = (strlen(urldecode($this->class->Data("c"))) > 250) ? substr(urldecode($this->class->Data("c")),0,250) : urldecode($this->class->Data("c"));
		$wid = $this->class->Data("wid");

		// Replace linebreaks
		$Comment = str_replace(array("\n","\r","\r\n"),"<br />",$Comment);
		$Comment = htmlspecialchars($Comment);

		//---------------------------------------
		// Does the wallpaper exist?
		//---------------------------------------

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->Data("wid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Res = $this->class->mysql->FetchResults($Result);
		$Wallpaper = $Res[0];

		if (count($Res) == 0)
		{
			die($this->class->lang->Phrase['wallpaper_noexist']);
		}

		$ammCom = intval($Res[0]['comments']);
		$ammCom++;

		//---------------------------------------
		// Are we replying to an existing comment?
		//---------------------------------------

		/*
		$Pattern = "/\(Reply: ([0-9]+)\)/";
		preg_match_all($Pattern, $Comment, $Reply);
		$rid = $Reply[1][0];

		if (intval($rid) != 0)
		{
			// Replace the comment
			$Comment = str_replace(array($Reply[0][0]."<br />", $Reply[0][0]),null,$Comment);
		}
		*/
		$rid = intval($this->class->Data("reply"));

		// Is the parent id a subcomment? If so, set it to the main parent id.
		$Query = "SELECT * FROM `comments` WHERE `id`='".$rid."'";
		$Result = $this->class->mysql->Query($Query);
		$Parent = $this->class->mysql->FetchResults($Result);

		if(count($Parent) == 0)
		{
			// Parent doesn't even exist.
			$rid = 0;
		} else
		{
			$parent_id = $Parent[0]['parent_id'];
			if ($parent_id != 0)
			{
				// Set parent id as main parent.
				$rid = $parent_id;
			}
		}

		//---------------------------------------
		// Check time between last comment
		//---------------------------------------

		$Query = "SELECT * FROM `comments` WHERE `ip`='" . $this->class->IPAddr()."' ORDER BY `id` DESC LIMIT 1";
		$Result = $this->class->mysql->Query($Query);
		$fetchedComment = $this->class->mysql->FetchResults($Result);

		$timeB = isset( $fetchedComment[0]['time'] ) ? time() - $fetchedComment[0]['time'] : 0;

		if( $timeB != 0 && $timeB < $this->timeBetween) {
			die( str_replace('{x}', $this->timeBetween, $this->class->lang->Phrase['min_wait']) );
		}

		$Comment = functions::RemoveCurseWords($Comment,$this->class->Settings['curse_words']);

		//---------------------------------------
		// Insert the comment
		//---------------------------------------

		$uid = (! isset($this->class->User['username']) || $this->class->User['username'] == null) ? -1 : $this->class->User['userid'];
		$user = (! isset($this->class->User['username'])) ? null : $this->class->User['username']; 

		// Guest
		$Query =	"INSERT INTO `comments` (`wid`,`uid`,`user`,`time`,`comment`,`ip`, `parent_id`) VALUES(";
		$Query .=	"'".$wid."','".$uid."','".$user."','".time()."','".$Comment."','".$this->class->IPAddr()."', '$rid')";
		$Result = $this->class->mysql->Query($Query);

		// Update the amount of wallpapers in the wallpapers category
		$Query = "UPDATE `wallpapers` SET `comments`=' " . $ammCom . "' WHERE `id`='".$wid."'";
		$Result = $this->class->mysql->Query($Query);

		//---------------------------------------
		// Send a message to the wallpaper owner
		//---------------------------------------

		$Author = $Wallpaper['author'];
		$Query = "SELECT * FROM `users` WHERE `username`='".$Author."'";
		$Result = $this->class->mysql->Query($Query);
		$User = $this->class->mysql->FetchResults($Result);

		$UserID = ( ! isset($User[0]['userid']) ) ? 0 : $User[0]['userid'];

		$Message = $this->comMessage;
		$Message = str_replace("&&wid&&", $Wallpaper['id'], $Message);
		$Message = str_replace("&&wallpaper&&", $Wallpaper['name'], $Message);

		$Query =	"INSERT INTO `messages` (`to`,`from`,`title`,`message`,`time`) VALUES('" . 
					$UserID . "', '0', '" . $this->comTitle . "', '" . addslashes($Message) . "', '" . time() . "')";

		$this->class->mysql->Query($Query);
		

		echo $this->class->lang->Phrase['com_success'];

		exit;

	}

	//----------------------------------------------------------
	// Name:	report()
	// Desc:	Report comments that may be offensive.
	//----------------------------------------------------------

	function report()
	{
		//---------------------------------------
		// Is the comment id valid?
		//---------------------------------------

		if ($this->class->Data("cid") == null || ! is_numeric($this->class->Data("cid")))
		{
			die($this->class->lang->Phrase['inv_id']);
		}

		//---------------------------------------
		// Does the comment exist?
		//---------------------------------------

		$Query = "SELECT * FROM `comments` WHERE `id`='".$this->class->Data("cid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Res = $this->class->mysql->FetchResults($Result);

		if (count($Res) == 0)
		{
			die($this->class->lang->Phrase['generic_noexist']);
		}

		//---------------------------------------
		// Check time between last report
		//---------------------------------------

		$Query = "SELECT * FROM `comment_reports` WHERE `ip`='" . $this->class->IPAddr()."' ORDER BY `id` DESC LIMIT 1";
		$Result = $this->class->mysql->Query($Query);
		$fetchedComment = $this->class->mysql->FetchResults($Result);

		$timeB = time() - $fetchedComment[0]['time'];

		if($timeB < $this->timeBetweenReports)
		{
			die(str_replace('{x}', $this->timeBetweenReports, $this->class->lang->Phrase['min_wait_report']));
		}

		//---------------------------------------
		// It exists, lets report it.
		//---------------------------------------

		$Query = "INSERT INTO `comment_reports` (`cid`, `ip`, `time`) VALUES('".$this->class->Data("cid")."', '".$this->class->IPAddr()."','".time()."')";
		$Result = $this->class->mysql->Query($Query);

		echo $this->class->lang->Phrase['com_reported'];

		exit;

	}

	//----------------------------------------------------------
	// Name:	LoadComment()
	// Desc:	Load the comments from the database into readable format.
	//----------------------------------------------------------


	function LoadComment()
	{
		//---------------------------------------
		// Retrieve the variables and verify input
		//---------------------------------------

		$this->return['path'] = null;
		$commentHTML = null;

		if ($this->class->Data("wid") == null || !is_numeric($this->class->Data("wid")))
		{
			die($this->class->lang->Phrase['inv_wid']);
		}

		if ($this->class->Data("page") == null || !is_numeric($this->class->Data("page")))
		{
			die($this->class->lang->Phrase['inv_page']);
		}
		$Page = $this->class->Data("page");

		//---------------------------------------
		// Does the wallpaper exist?
		//---------------------------------------

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->Data("wid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Res = $this->class->mysql->FetchResults($Result);

		if (count($Res) == 0)
		{
			die($this->class->lang->Phrase['wallpaper_noexist']);
		}

		//---------------------------------------
		// Lets do the pagination
		//---------------------------------------

		// Get amount of comments
		$Query = "SELECT COUNT(*) FROM `comments` WHERE `wid` = ".$this->class->Data("wid")." AND `parent_id` = 0";
		$Res = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Res);
		$Amount = $Amount[0]["COUNT(*)"];

		// Start val
		$Start = intval($this->class->Data("page") * $this->CommentsPerPage - $this->CommentsPerPage);

		$Query = "SELECT * FROM `comments` WHERE `wid` = ".$this->class->Data("wid")." AND `parent_id` = 0 ORDER BY `time` DESC LIMIT ".$Start.",".$this->CommentsPerPage;
		$Res = $this->class->mysql->Query($Query);
		$Comments = $this->class->mysql->FetchResults($Res);
			
			if(count($Comments) == 0)
			{
				// There are 0 comments
				$commentHTML = $this->class->lang->Phrase['wall_nocomments'];
			} else
			{
				// Lets figure out the pagination
			$Pages = ceil($Amount / $this->CommentsPerPage);
			if ($Pages > 1)
			{
				if ($Page == 1)
				{
					// We chose the first page
					if($Pages == 1)
					{
						$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
					} elseif ($Pages == 2 || $Pages == 3)
					{
						$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
						for($x = 2; $x <= $Pages; $x++)
						{
							$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $x));
						}
					} elseif ($Pages > 3)
					{
						$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
						for($x = 2; $x <= 3; $x++)
						{
							$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $x));
						}
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_morepages.cphp", array());
					}
					// Prev/next - we only need next
					if ($Pages > 1)
					{
						$PrevNext = $this->class->template->LoadTemplate("display/comments_next.cphp", array("next" => $Page + 1));
					} else
					{
						$PrevNext = $this->class->template->LoadTemplate("display/comments_next.cphp", array("next" => '&nbsp;'));
					}
				} elseif ($Page == $Pages)
				{
					if ($Pages == 2)
					{
						// If there are only 2 pages, and we clicked the second
						$pagHTML = $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => 1));
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 2));
					} else if ($Pages >= 3)
					{
						// If there are 3 or more pages, and we clicked the last
						$strt = $Page - 2;
						for($x = $strt; $x <= ($strt+1); $x++)
						{
							$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $x));
						}
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => $Page));
					}
					// Prev/next - we only need previous
					$PrevNext = $this->class->template->LoadTemplate("display/comments_previous.cphp", array("previous" => $Page - 1));
				} else
				{
					// If we did not click the first or last. there is always one in between
					$pagHTML = $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $Page-1));
					$pagHTML .= $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => $Page));
					$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $Page+1));
					if($Page + 1 != $Pages)
					{	
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_morepages.cphp", array());
					}
					// Prev/next - we need both next and previous
					$PrevNext = $this->class->template->LoadTemplate("display/comments_prevnext.cphp", array(
						"next" => ($Page + 1), "previous" => ($Page - 1)));
				}
			}

				// Output the comments
				$ide = 0;
				foreach($Comments as $Comment)
				{
					$time = $this->class->functions->TimeAgo($Comment['time']);
					
					if($Comment['uid'] == '-1')
					{
						// It's a guest.
						$User = $this->class->template->LoadTemplate("display/comment_guest.cphp", array());
					} else
					{
						$User = $this->class->template->LoadTemplate("display/comment_user.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $Comment['user']),
							"user"		=> $Comment['user'],
						));
					}

					// Figure out the rating color and font-weight
					$color = (intval($Comment['rating']) < 0) ? "#FF3333" : "#000000";
					$Weight = (intval($Comment['rating']) < 0 || intval($Comment['rating']) > 0) ? "bold" : 0;
					if (intval($Comment['rating']) > 0) {
						$color = "#77AB49";
					}

					// Has the user rated this comment already?
					$checkQuery = "SELECT * FROM `comment_ratings` WHERE `cid`='".$Comment['id']."' AND `ip`='".$this->class->IPAddr()."'";
					$checkRes = $this->class->mysql->Query($checkQuery);
					$Check = $this->class->mysql->FetchResults($checkRes);
					if (count($Check) == 0)
					{
						// Hasn't rated.
						$rHTML = $this->class->template->LoadTemplate("display/rating.cphp", array("cid" => $Comment['id']));
					} else
					{
						// Has rated.
						if ($Check[0]['type'] == 'p')
						{
							// Positive
							$rHTML = $this->class->template->LoadTemplate("display/rating_p.cphp", array());
						} else
						{
							// Negative
							$rHTML = $this->class->template->LoadTemplate("display/rating_n.cphp", array());
						}
					}

					// If the comment has been sunk
					if (intval($Comment['rating']) <= $this->commentSunk)
					{
						$commentHTML .= $this->class->template->LoadTemplate("display/comment_sunk.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $Comment['user']),
							"user"		=> $Comment['user'],
							"message"	=> $Comment['comment'],
							"time"		=> $time[0]." ".$time[1],
							"userHTML"	=> $User,
							"cid"		=> $Comment['id'],
							"xid"		=> $ide,
							"color"		=> $color,
							"rating"	=> $Comment['rating'],
							"weight"	=> $Weight,
							"rhtml"		=> $rHTML,
						));
					} else
					{
						$commentHTML .= $this->class->template->LoadTemplate("display/comment.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $Comment['user']),
							"user"		=> $Comment['user'],
							"message"	=> $Comment['comment'],
							"time"		=> $time[0]." ".$time[1],
							"userHTML"	=> $User,
							"cid"		=> $Comment['id'],
							"color"		=> $color,
							"rating"	=> $Comment['rating'],
							"weight"	=> $Weight,
							"rhtml"		=> $rHTML,
						));
					}

					//---------------------------
					// Get child comments
					//---------------------------

					$Query = "SELECT * FROM `comments` WHERE `parent_id`='" . $Comment['id']."'";
					$Result = $this->class->mysql->Query($Query);
					$Subcomments= $this->class->mysql->FetchResults($Result);
					
					foreach($Subcomments as $subComment)
					{
						$ide++;
						// Has the user rated this comment already?
						$checkQuery = "SELECT * FROM `comment_ratings` WHERE `cid`='".$subComment['id']."' AND `ip`='".$this->class->IPAddr()."'";
						$checkRes = $this->class->mysql->Query($checkQuery);
						$Check = $this->class->mysql->FetchResults($checkRes);
						if (count($Check) == 0)
						{
							// Hasn't rated.
							$rHTML = $this->class->template->LoadTemplate("display/rating.cphp", array("cid" => $subComment['id']));
						} else
						{
							// Has rated.
							if ($Check[0]['type'] == 'p')
							{
								// Positive
								$rHTML = $this->class->template->LoadTemplate("display/rating_p.cphp", array());
							} else
							{
								// Negative
								$rHTML = $this->class->template->LoadTemplate("display/rating_n.cphp", array());
							}
						}

						// Figure out the rating color and font-weight
						$color = (intval($subComment['rating']) < 0) ? "#FF3333" : "#000000";
						$Weight = (intval($subComment['rating']) < 0 || intval($subComment['rating']) > 0) ? "bold" : 0;
						if (intval($subComment['rating']) > 0) {
							$color = "#77AB49";
						}

						$time = $this->class->functions->TimeAgo($subComment['time']);
					
						if($subComment['uid'] == '-1')
						{
							// It's a guest.
							$User = $this->class->template->LoadTemplate("display/comment_guest.cphp", array());
						} else
						{
							$User = $this->class->template->LoadTemplate("display/comment_user.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $subComment['user']),
								"user"		=> $subComment['user'],
							));
						}

						if (intval($subComment['rating']) <= $this->commentSunk)
						{
							$commentHTML .= $this->class->template->LoadTemplate("display/subcomment_sunk.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $Comment['user']),
								"user"		=> $subComment['user'],
								"message"	=> $subComment['comment'],
								"time"		=> $time[0]." ".$time[1],
								"userHTML"	=> $User,
								"cid"		=> $subComment['id'],
								"xid"		=> $ide,
								"color"		=> $color,
								"rating"	=> $subComment['rating'],
								"weight"	=> $Weight,
								"rhtml"		=> $rHTML,
							));
						} else
						{
							$commentHTML .= $this->class->template->LoadTemplate("display/subcomment.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> str_replace(" ", $this->class->Settings['identifier'], $subComment['user']),
								"user"		=> $subComment['user'],
								"message"	=> $subComment['comment'],
								"time"		=> $time[0]." ".$time[1],
								"userHTML"	=> $User,
								"cid"		=> $subComment['id'],
								"color"		=> $color,
								"rating"	=> $subComment['rating'],
								"weight"	=> $Weight,
								"rhtml"		=> $rHTML,
							));
						}
					}
					$ide++;

				}
			}


		// Retrieve pagination HTML
		$commentHTML .= ($Pages > 1) ? $this->class->template->LoadTemplate("display/paghtml.cphp", array("comment_pages" => $pagHTML, "prevnext" => $PrevNext)) : null;

		echo $commentHTML;
		exit;

	}

	//----------------------------------------------------------
	// Name:	rate()
	// Desc:	Rate a comment either positively or negatively.
	//----------------------------------------------------------
	
	function rate()
	{

		//---------------------------------------
		// Retrieve the variables and verify input
		//---------------------------------------

		if ($this->class->Data("cid") == null || !is_numeric($this->class->Data("cid")))
		{
			die($this->class->lang->Phrase['inv_id']);
		}

		if ($this->class->Data("val") == null)
		{
			die($this->class->lang->Phrase['generic_noexist']);
		}

		if($this->class->Data("val") != "n" && $this->class->Data("val") != "p")
		{
			die($this->class->lang->Phrase['generic_noexist']);
		}

		$val = $this->class->Data("val");

		//---------------------------------------
		// Does the comment exist?
		//---------------------------------------

		$Query = "SELECT * FROM `comments` WHERE `id`='".$this->class->Data("cid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Comment = $this->class->mysql->FetchResults($Result);

		if (count($Comment) == 0)
		{
			die($this->class->lang->Phrase['generic_noexist']);
		}

		//---------------------------------------
		// Have we already rated it?
		//---------------------------------------

		$Query = "SELECT COUNT(*) FROM `comment_ratings` WHERE `cid`='".$this->class->Data("cid")."' AND `ip`='".$this->class->IPAddr()."'";
		$Result = $this->class->mysql->Query($Query);
		$Res = $this->class->mysql->FetchResults($Result);

		if ($Res[0]["COUNT(*)"] > 0)
		{
			die($this->class->lang->Phrase['already_rate']);
		}

		//---------------------------------------
		// Submit our rating
		//---------------------------------------

		$Add = ($val == "n") ? -1 : 1;
		$Rating = intval($Comment[0]['rating']) + $Add;
		
		$Query = "UPDATE `comments` SET `rating`='".$Rating."' WHERE `id`='".$this->class->Data("cid")."'";
		$Res = $this->class->mysql->Query($Query);
		
		$Query = "INSERT INTO `comment_ratings` (`cid`,`ip`,`type`,`time`) VALUES('".$this->class->Data("cid")."','".$this->class->IPAddr()."','".$val."','".time()."')";
		$Res = $this->class->mysql->Query($Query);
		
		echo $this->class->lang->Phrase['rate_success'];
		exit;

	}

}

?>