<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Members
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Members
{

	var $class;

	//---------------------------------------------------------------
	// auto_run
	// Default function called by parent class.
	//---------------------------------------------------------------

	function auto_run()
	{
		Functions::$Var['Selected'] = 3;

		//-----------------------------------------------------------
		// What are we doing?
		//-----------------------------------------------------------

		switch($this->class->main->Data("do"))
		{
			case 'edit':
				return $this->edit();
				break;
			case 'submit_ban':
				return $this->submit_ban();
				break;
			case 'ban':
				return $this->ban();
				break;
			case 'banned':
				return $this->banned();
				break;
			case 'mailing':
				return $this->mailing();
				break;
			case 'search':
				return $this->search();
				break;
			case 'submit_search':
				return $this->submit_search();
				break;
			case'user':
				return $this->edit_user();
				break;
			case 'submit_edit':
				return $this->submit_edit();
				break;
			case 'delete':
				return $this->delete();
				break;
			case 'confirm_delete':
				return $this->confirm_delete();
				break;

			default:
				return $this->users();
				break;
		}

	}

	function confirm_delete()
	{
		Functions::DemoCheck();

		if ($this->class->main->Data("users") == null)
			Functions::AdminError("You must select some wallpapers to delete.");

		// Sort wallpapers in to array.
		$Users = explode("|",$this->class->main->Data("users"));
		
		// Go through wallpapers we want to delete.
		foreach($Users as $id)
		{
			if ($id != null)
			{
				// Retrieve the wallpaper details
				$Query = "DELETE FROM users WHERE userid = '" . $id . "'";
				$Result = $this->class->main->mysql->Query($Query);
			}
		}
	
		// All wallpapers deleted. Let's redirect.
		Functions::Redirect('The selected user(s) have been deleted', 'index.php?act=members');


	}

	//---------------------------------------------------------------
	// Delete a wallpaper
	// Outputs confirmation screen prior to deleting
	//---------------------------------------------------------------

	function delete()
	{
		// Are we deleting a single wallpaper? (i.e. did we click the delete icon)
		if (array_key_exists('id', $_REQUEST) != false && count($_REQUEST['id']) != 0)
			$_REQUEST['users'][0] = $_REQUEST['id'];

		// Are we deleting multiple wallpapers?
		if (array_key_exists('users', $_REQUEST) == false || count($_REQUEST['users']) == 0)
			Functions::AdminError("You must select at least one user to delete.");

		// Retrieve wallpaper ids from posted array, sort in to string. Easier to re-post.
		$Delete = null;
		foreach($_REQUEST['users'] as $id)
			$Delete	.= addslashes($id)."|";
				
		// Build output data
		$Content = Functions::LoadTemplate("delete_users", array('walls' => $Delete));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=members&do=confirm_delete', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation'));
		$HTML = Functions::BuildSection('Delete Confirmation', $Content);

		return $HTML;

	}


	function submit_edit()
	{
		Functions::DemoCheck();

		$UserId = $this->class->main->Data("userid");

		if( empty($UserId) || ! is_numeric($UserId))
			Functions::AdminError("Must enter a valid user id.");

		// Does the user exist?
		$Query = "SELECT *, COUNT(*) FROM users WHERE userid = '" . $UserId."' GROUP BY userid";
		$Result = $this->class->main->mysql->Query($Query);
		$User = $this->class->main->mysql->FetchResults($Result);
		$User = $User[0];

		if( (int) $User['COUNT(*)'] == 0 )
			Functions::AdminError("User does not exist.");

		$Posted = $this->class->main->Data("Post");

		$Query = null;
		foreach($Posted as $Id => $Post)
		{
			if(! empty($Post))
			{
				if($Id == 'password')
					$Post = md5($Post);

				if(array_key_exists($Id, $User))
				{
					if($Post != $User[$Id])
					{
						$Query .= "`" . $Id . "` = '" . $Post . "', ";
					}
				}
			}
		}

		if($Query != null)
		{
			$Query = substr($Query, 0, strlen($Query) - 2);
			$Update = "UPDATE users SET " . $Query . " WHERE userid = " . $UserId;
			$this->class->main->mysql->Query($Update);
		}

		// Redirect
		Functions::Redirect( "User " . $User['username'] . " has been edited", 'index.php?act=members' );

	}

	function edit_user()
	{
		$User = $this->class->main->Data("u");

		if( empty($User) )
			Functions::AdminError("Must enter either a username or user id.");

		// What are we looking up. ID or username?
		if(is_numeric($User))
		{
			$Query = "userid = " . $User;
		} else
		{
			$Query = "username = '" . $User . "'";
		}

		$Search = "SELECT *, COUNT(*) FROM users WHERE " . $Query . " GROUP BY userid LIMIT 1";
		$Result = $this->class->main->mysql->Query($Search);
		$DbUser = $this->class->main->mysql->FetchResults($Result);
		$user = $DbUser[0];

		if((int) $user['COUNT(*)'] == 0)
			Functions::AdminError("User does not exist.");

		$Edit = Functions::LoadTemplate("edit_user", $user);
		$Edit = Functions::LoadTemplate("form", array("action" => '?act=members&do=submit_edit', 'method' => 'post', 'content' => $Edit, 'id' => '', 'class' => 'search_form general_form'));
		$Edit = Functions::BuildSection( "Edit user", $Edit);

		return $Edit;

	}
		

	function submit_search()
	{
		$Search = $this->class->main->Data("Search");

		// Select the table struture
		$Query = "DESCRIBE users";
		$Result = $this->class->main->mysql->Query($Query);
		$Table = $this->class->main->mysql->FetchResults($Result);

		// Sort structure in to an array
		$Tables = array();
		foreach($Table as $tbl)
			$Tables[] = $tbl['Field'];
	
		// Go through posted data.
		$SearchQuery = null;
		foreach($Search as $Id => $Val)
		{
			if( ! empty($Val) )
			{
				if( in_array( $Id, $Tables ) )
				{
					$SearchQuery .= "`" . $Id . "` LIKE '%" . $Val . "%' AND ";
				} else
				{
					// Join dates
					$Pattern = "/(\d\d\d\d)-(\d\d)-(\d\d)/";

					// Before?
					if($Id == 'join_before')
					{
						preg_match_all($Pattern, $Val, $Date);

						if( count($Date[0]) == 0 || ! is_array($Date[0]) )
							Functions::AdminError("Invalid date format.");
						$SearchQuery .= "`join` < " . strtotime($Val) . " AND ";

					//  After
					} else if ($Id == 'join_after')
					{
						preg_match_all($Pattern, $Val, $Date);

						if( count($Date[0]) == 0 || ! is_array($Date[0]) )
							Functions::AdminError("Invalid date format.");
						$SearchQuery .= "`join` > " . strtotime($Val) . " AND ";
					}

				}
			}
		}

		// If no data was posted.
		if($SearchQuery == null)
			Functions::AdminError("You must enter some search criteria.");

		// Trim the search query
		$SearchQuery = substr($SearchQuery, 0, strlen($SearchQuery) - 5);

		// Perform the query
		$Query = "SELECT * FROM users WHERE " . $SearchQuery;
		$Result = $this->class->main->mysql->Query($Query);
		$Users = $this->class->main->mysql->FetchResults($Result);

		// Let's output the results
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_users_table_start", array());

		foreach($Users as $User)
		{
			$User['join_date'] = date("m/d/Y", $User['join']);
			$tbl .= Functions::LoadTemplate("wrapper_user_entry", $User);
		}
		
		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("wrapper_user_options", array());
	
		$tbl = Functions::BuildSection("Search Results", $tbl, array('table' => '1'));
		return $tbl;

	}

	function search()
	{
		$Search = Functions::LoadTemplate("search_users");
		$Search = Functions::LoadTemplate("form", array("action" => '?act=members&do=submit_search', 'method' => 'post', 'content' => $Search, 'id' => '', 'class' => 'search_form general_form'));
		$Search = Functions::BuildSection("Search for Users", $Search);
	
		return $Search;

	}

	function mailing()
	{

		$Query = "SELECT email FROM users ORDER BY email ASC";
		$Result = $this->class->main->mysql->Query($Query);
		$Emails = $this->class->main->mysql->FetchResults($Result);

		$List = null;
		foreach($Emails as $Email)
			$List .= $Email['email'] . ", ";

		$List = substr($List, 0, strlen($List) - 2);

		$file = 'tmp/mailing_' . rand(1000000, 100000000) . '.txt';
		file_put_contents($file, $List);

		header('Content-type: text');
		header('Content-Disposition: attachment; filename="' . $file . '"');

		readfile($file);
		unlink($file);
		exit;

	}

	function banned()
	{
		$Query = "SELECT * FROM bans INNER JOIN users ON bans.uid = users.userid GROUP BY bans.id";
		$Result = $this->class->main->mysql->Query($Query);
		$Banned = $this->class->main->mysql->FetchResults($Result);

		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_banned_table_start", array());

		foreach($Banned as $Ban)
			$tbl .= Functions::LoadTemplate("wrapper_banned_entry", $Ban);
		
		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("table_banned_options", array());

		// Build it from the template
		$Section = Functions::BuildSection("Banned Users", $tbl, array('table' => 1));

		return $Section;


	}

	function submit_ban()
	{
		Functions::DemoCheck();

		$Username = $this->class->main->Data("username");
		$Reason = $this->class->main->Data("reason");

		if($Username == null)
			Functions::AdminError("You must enter a username to ban.");

		// Did we select ourselves?
		if(strtolower($Username) == strtolower($this->class->Admin['username']))
			Functions::AdminError("You may not ban yourself.");

		// Does the user exist?
		$Query = "SELECT COUNT(*), `userid` FROM `users` WHERE `username` = '" . $Username  . "' GROUP BY userid";
		$Result = $this->class->main->mysql->Query($Query);
		$User = $this->class->main->mysql->FetchResults($Result);
		$User = $User[0];

		if((int) $User['COUNT(*)'] == 0)
			Functions::AdminError("That user does not exist.");

		// Let's ban
		$Query = "UPDATE `users` SET `usergroup` = '-1' WHERE `username` = '" . $Username . "'";
		$Result = $this->class->main->mysql->Query($Query);

		// Insert in to bans
		$Query = "INSERT INTO `bans` (`uid`, `aid`, `time`, `reason`) VALUES(" . $User['userid'] . ", " . $this->class->Admin['userid'] . ", " . time() . ", '" . $Reason . "')";
		$Result = $this->class->main->mysql->Query($Query);

		// Redirect
		Functions::Redirect( "User " . $Username . " has been banned", 'index.php?act=members&do=ban' );


	}

	function ban()
	{
		$tbl = Functions::LoadTemplate("banuser");
		$tbl = Functions::LoadTemplate("form", array("action" => '?act=members&do=submit_ban', 'method' => 'post', 'content' => $tbl, 'id' => '', 'class' => 'search_form general_form'));
		$tbl = Functions::BuildSection("Ban User", $tbl);

		return $tbl;



	}

	// Default users
	function users()
	{
		// Perform the query
		$Query = "SELECT * FROM users LIMIT 0,30";
		$Result = $this->class->main->mysql->Query($Query);
		$Users = $this->class->main->mysql->FetchResults($Result);

		// Let's output the results
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_users_table_start", array());

		foreach($Users as $User)
		{
			$User['join_date'] = date("m/d/Y", $User['join']);
			$tbl .= Functions::LoadTemplate("wrapper_user_entry", $User);
		}
		
		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("wrapper_user_options", array());

		$tbl = Functions::LoadTemplate("form", array("action" => '?act=members&do=delete', 'method' => 'post', 'content' => $tbl, 'id' => '', 'class' => ''));
		$tbl = Functions::BuildSection("User Accounts", $tbl, array('table' => '1'));
		return $tbl;
	}


}

?>