<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Admin
|   > Script written by Alex Roxon
|   > Date started: Apr 21 2009
|	> Last updated: Mar 11 2010
|	> Revisions: 1
|
+--------------------------------------------------------------------------
*/

session_start();

include("includes/functions.php");
$functions = new Functions();

class Admin 
{

	public $path="";
	public $functions="";
	public $Admin;

	public $Calendar;
	static $Vars = array();
	public $main;

	public $Demo = false;

	function getClass() { return $this; }

	function auto_run() 
	{
		// Script path
		$Path = '../';

		// We are from the admin control panel
		$Admin = true;

		include_once("../index.php");

		$this->main = $Wallpaper;
		Functions::$Var['class'] = $Wallpaper;
		
		$this->Admin = Functions::Admin_Details();
		$this->path = str_replace("admin/index.php", NULL, $_SERVER['SCRIPT_FILENAME']);

		$Act = (array_key_exists('act', $_GET)) ? addslashes($_GET['act']) : null;
		$Replace=array();

		// Variable declarations
		$html = null;
		$HTML = array();

		//-----------------------------------------------
		// If we are attempting to log in
		// What to do?
		//-----------------------------------------------

		if ($Act == "login")
		{
			$username=$_REQUEST['username'];
			$special_request = true;
			$login = Functions::check_login($_POST['username'], $_POST['password']);

			//-------------------------------------------
			// If the login returned false, output error
			//-------------------------------------------

			if (intval($login!=1)) 
			{
				$Error = Functions::LoadTemplate("login_error", array("error" => $login));
				$replaceVariables=array(
							"error" => $Error,
							"username" => $username,
							"password" => null,
						);
				$html=Functions::LoadTemplate("not_logged_in",$replaceVariables);
				die($html);
			}

			//-------------------------------------------
			// If the login returned true, return to index
			//-------------------------------------------
			
			$_SESSION['time'] = time();

			$replaceVariables=array(
					"title" => "You are now logged in",
					"url" => "index.php?",
					"delay" => 3,
			);

			$html=Functions::LoadTemplate("loading",$replaceVariables);
			echo $html;
			exit;

		//-----------------------------------------------
		// If we are trying to log out
		//-----------------------------------------------

		} elseif ($Act == "logout")
		{
			//-------------------------------------------
			// Clear cookies and move on
			//-------------------------------------------

			setcookie('username', "", time()+604800);
			setcookie('password', "", time()+604800);
			
			$replaceVariables=array(
					"title" => "You are now logged out",
					"url" => "index.php?",
					"delay" => 3,
			);

			$html=Functions::LoadTemplate("loading",$replaceVariables);
			echo $html;
			exit;
		}

		//-----------------------------------------------
		// If we are not logged in, output login form
		//-----------------------------------------------

		if ($html==null) 
		{
			$_SESSION['time'] = time();
			if (Functions::check_logged() == false || intval(time()) - $_SESSION['time'] > 3600) // session lasts one hour
			{
				$replaceVariables=array(
								"error" => null,
								"username" => null,
								"password" => null,
				);
				$html=Functions::LoadTemplate("not_logged_in",$replaceVariables,1);
				die($html);
			}
		}

		//---------------------------------------
		// Admin pages
		//---------------------------------------

		$Include_Pages = array (

			//-----------------------------------
			// WallScript
			//-----------------------------------

			"wallpapers"				=>	array("includes/wallpapers.php", "Wallpapers"),
			"members"					=>	array("includes/members.php", "Members"),
			"bulk"						=>	array("tmp/bulk.php", "Bulk"),
			"main"						=>	array("includes/main.php", "Index"),
			"plugins"					=>	array("includes/plugins.php", "Plugins"),
			"styles"					=>	array("includes/styles.php", "Styles"),
			"content"					=>	array("includes/content.php", "Content"),

		);

		Functions::$Var['replace_template'] = true;

		// Mclass, admin
		if( ! isset(Functions::$Var['mclass'])) Functions::$Var['mclass'] = $this->main;
		if( ! isset(Functions::$Var['admin'])) Functions::$Var['admin'] = $this->Admin;

		// Demo
		Functions::$Var['demo'] = $this->Demo;

		if ($Act == null || array_key_exists($Act, $Include_Pages) == false || is_null($Include_Pages[$Act])) 
		{
			include_once("includes/main.php");
			$main = new Index();
			$do = (array_key_exists('do', $_GET)) ? $_GET['do'] : null;
			$pageHTML = ($do != 'update') ? $main->logged_in_page() : $main->update();

		} else
		{
			$file = $Include_Pages[$_GET['act']][0];
			$class = $Include_Pages[$_GET['act']][1];

			include_once($file);
			$classfile = new $class;
			$classfile->class = $this;

			$pageHTML = $classfile->auto_run();

		}

		//-----------------------------------------------
		// Output the html
		//-----------------------------------------------

		if (array_key_exists('title', $Replace) == false || $Replace['title']==null) $Replace['title']='Admin Home';
		
		if(is_array($HTML) && array_key_exists('navigation', $HTML)) 
		{
			echo 1;
			$Replace['menu'] = $HTML['navigation'];
		}
		
		if( ! isset(Functions::$Var['admin'])) Functions::$Var['admin'] = $this->Admin;
		if( ! isset(Functions::$Var['mclass'])) Functions::$Var['mclass'] = $this->main;

		$page = Functions::BuildPage($pageHTML);
		echo $page;

	}

}

$Admin=new Admin();
$Admin->auto_run();

?>
