<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Wallpaper
|   > Script written by Alex Roxon
|   > Date started: Mar 09 2009
|	> Date updated: Apr 28 2010
|
+--------------------------------------------------------------------------
*/

class Wallpaper
{
    
    // Classes
    public $lang;
    public $mysql;
    public $template;
    public $file;
	public $functions;
	public $Recaptcha;
	public $Debug;

	public $scriptPath;
	public $Admin;
     
    public $cn;
    public $Output;
    public $function;
    public $_REQUEST;
	public $URL;

	// Counts
	public $numError = 0;
    
    // Arrays
    public $MySQL = array();
    public $Settings = array();
    public $Replace = array();
    public $files = array();
	public $page = array();
	public $User = array();
	public $Cookie;
	public $Plugins = array();
	public $PluginSettings = array();

	// Return
	public $return;
    
    //---------------------------------------------------------
    // Name:    __construct()
    // Desc:    Main function called when index.php loads
    //---------------------------------------------------------
    
    function __construct($Path = '', $Admin = false)
    {
		// Script path
		$this->scriptPath = $Path;
		
		// Are we running admin?
		$this->Admin = $Admin;

		// MySQL Prefix
		define("PREFIX", null);

		// Are we currently in the script?
		define("IN_SCRIPT", true);

		// Do we currently have necessary permissions?
		define("WSPERMS", true);

		// Current PHP version
		define("PHPVERSION", phpversion());

		// WallScript version
		define("VERSION", (float) "1.1.1");

		global $_COOKIE;

        // Includes
        include_once("includes/mysql.php" );
        include_once("language/en.php");
        include_once("sources/private/mysql.class.php");
        include_once("sources/private/template.class.php");
		include_once("includes/functions.php");	
		include_once("includes/recaptchalib.php");
		include_once("sources/private/debug.php");

		// Constants
		define("INSTALLED", ( isset( $Installed ) && $Installed == 1 ) ? true : false);

		// Do we have to install?
		if( INSTALLED == false ) {
			header("Location: install/install.php");
			exit;
		}
        
        // Run the classes
        $this->lang = new Language;
        $this->mysql = new mysql;
		$this->functions = new functions;
		$this->Recaptcha = new ReCaptcha;
		$this->Debug = new Debug( $this );

		// If we're not running from admin initiate
		if($this->Admin == false) functions::$class = $this;

		// Lets just initiate some of the classes
		$this->mysql->wpclass = $this;
        
        // Connect to mysql. Grab the settings
        $this->ConnMysql($MySQL);
        $this->Settings();

		/*----------------------------------------------------------------
		 * Start edit version 1.1.2 - define root URL and script path.
		 *----------------------------------------------------------------*/

		$Root = $this->Settings[ 'Website_URL' ];
		$Root .= ( substr( $Root, -1 ) !== "/" ) ? "/" : ""; // Add a trailing slash?
		
		define( "WS_URL", $Root );
		define( "WS_PATH", dirname(__FILE__) );

		/*-----------------------------------------------------------------
		 * End edit version 1.1.2
		 *-----------------------------------------------------------------*/

		$this->auto_run();

	}

	
    //---------------------------------------------------------
    // Name:    auto_run()
    // Desc:    Execute primary method.
    //---------------------------------------------------------

	function auto_run()
	{

		//-------------------------------------------------------
		// Plugins
		//-------------------------------------------------------

		$Query = $_SERVER['QUERY_STRING'];
		$Script = $_SERVER['SCRIPT_NAME'];
		if(strrpos($Script, '/') > 0) $Script = substr($Script, strrpos($Script, '/') + 1, strlen($Script));

		$Page = array($Script, $Query);

		$Query = "SELECT * FROM `plugin_code` WHERE (`script` LIKE '%" . $Page[0]. ";' OR `script` LIKE '*')";
		$Result = $this->mysql->Query($Query);
		$Code = $this->mysql->FetchResults($Result);

		$Plugins = array();
		foreach($Code as $Plugin)
		{
			if($Plugin['query'] == '*') 
				$Plugins[$Plugin['called']][] = $Plugin;
			else
			{
				if(! empty($Plugin['query']) && strpos('_' . $Page[1], $Plugin['query']) > 0)
					$Plugins[$Plugin['called']][] = $Plugin;
				elseif($Plugin['query'] == $Page[1])
					$Plugins[$Plugin['called']][] = $Plugin;
			}
		}

		$this->Plugins = functions::sift_plugins($Plugins);

		//-------------------------------------------------
		// Select plugin settings
		//-------------------------------------------------

		$Query = "SELECT * FROM plugin_settings";
		$Result = $this->mysql->Query($Query);
		$pSettings = $this->mysql->FetchResults($Result);
		
		foreach($pSettings as $pSet) {
			$this->PluginSettings[ $pSet['identifier'] ][ $pSet['name'] ] = $pSet['value'];
		}

		// What identifier?
		switch($this->Settings['define_seperator'])
		{
			case 1:
				$Ide = "-";
				break;
			case 2:
				$Ide = "_";
				break;
			case 3:
				$Ide = ".";
				break;
			default:
				$Ide = "-";
				break;
		}
		$this->Settings['identifier'] = $Ide;

		// Get the user details
		$this->UserDetails();
        
        // Load the template
        $this->template = new template();
        $this->template->Wall = $this;
        
        // Misc
        $this->_REQUEST = $_REQUEST;

		// If this is disabled?

		if($this->Admin == false)
		{
        
			// The files we need to load
			$this->files = array(
				"home"          => array("Index", "sources/public/home.php"),
				"wallpaper"     => array("Display", "sources/public/wallpaper.php"),
				"searchSuggest" => array("Search", "sources/private/searchSuggest.php"),
				"downloads"		=> array("Download", "sources/public/download.php"),
				"vote"			=> array("Vote", "sources/private/vote.php"),
				"comment"		=> array("Comment", "sources/private/comment.php"),
				"categories"	=> array("Categories", "sources/public/categories.php"),
				"user"			=> array("User", "sources/public/user.php"),
				"search"		=> array("Search", "sources/public/search.php"),
				"affiliates"	=> array("Affiliates", "sources/public/affiliates.php"),
				"disabled"		=> array("Disabled", "sources/private/disabled.php"),
				"404"			=> array("NotFound", "sources/private/404.php"),
				"contact"		=> array("Contact", "sources/public/contact.php"),
				"viewwallpaper"	=> array("View", "sources/private/view.php"),
				"error"			=> array("Error", "sources/private/error.php"),
				"cms"			=> array("CMS", "sources/public/cms.php"),
			);

			// Lets get some variables ready
			$this->URL = str_replace("index.php", null, "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME']);
			
			// What to do?
			if($this->Data("act") != null)
			{
				if (array_key_exists($this->Data("act"), $this->files))
					$this->function = $this->Data("act");
				else $this->function = "home";
			} else
				$this->function = "home";
			
			// Run the first batch of plugins 
			$this->RunPlugin( $Plugins, 0 );

			// Load and execute the class to be loaded
			$TemplatePHP = $this->Settings['Template'] . 'php/' . $this->files[$this->function][1];
			if( ! file_exists( $TemplatePHP ) ) {
				include_once($this->files[$this->function][1]);
			} else {
				include_once( $TemplatePHP );
			}

			$this->file = new $this->files[$this->function][0]();
			$this->file->class = $this;
			$this->return = $this->file->run();

			// Run the second batch of plugins
			$this->RunPlugin( $Plugins, 1 );

			$this->Replace = $this->file->return;

			// Load the templates
			$this->BuildHeader();
			$this->Output .= $this->return;

			// Run the third batch of plugins
			$this->RunPlugin( $Plugins, 2 );

			//Build the footer
			$this->BuildFooter();

			// Run the fourth batch of plugins
			$this->RunPlugin( $Plugins, 3 );
			
			// Output
			$this->Display();

			// Added version 1.1.2. Did we experience any errors?
			$this->Debug->Out();

			exit;
		}
        
    }
	
    //---------------------------------------------------------
    // Name:    RunPlugin()
    // Desc:    Execute plugin.
    //---------------------------------------------------------

	public function RunPlugin( $Plugin, $Key ) 
	{
		if(isset( $Plugin[$Key] ) && is_array( $Plugin[$Key] ))
		{
			foreach($Plugin[$Key] as $P)
			{
				if( isset($P['TemplateDir']) && $P['TemplateDir'] != null ) 
				{
					$Template = $this->Settings['Template'];
					$Template = str_ireplace("templates/", null, $Template);

					if( substr( $Template, -1 ) == "/" ) {
						$Template = substr( $Template, 0, strlen($Template) - 1 );
					}

					if( strtolower( $Template ) == strtolower( $P['TemplateDir'] ) ) {
						eval( $P['code'] );
					}

				} else {
					eval($P['code']);
				}
			}
		}
	}
    
    //---------------------------------------------------------
    // Name:    CompilePartners()
    // Desc:    Loads the partners HTML
    //---------------------------------------------------------
    
    function CompilePartners()
    {
        $Query = "SELECT * FROM `partners` ORDER BY `anchor`";
        $Res = $this->mysql->Query($Query);
        $Cats = $this->mysql->FetchResults($Res);
        
        $ret = $this->template->LoadTemplate("global/partner_title.cphp", $this->lang->Phrase);
        
        foreach ($Cats as $val) {
            $ret .= $this->template->LoadTemplate("global/partner.cphp",
                array("url" => $val['url'], "name" => $val['anchor']));
        }
        return $ret;
    }
    
    //---------------------------------------------------------
    // Name:    CompileCategories()
    // Desc:    Loads the category HTML
    //---------------------------------------------------------
    
    
    function CompileCategories()
    {
		// Alphabetize?
		if($this->Settings['alphabetize_cats'] == '1') $Extra = ' ORDER BY `name`';

        $Query = "SELECT * FROM `categories` WHERE `parent`=''" .$Extra;
        $Res = $this->mysql->Query($Query);
        $Cats = $this->mysql->FetchResults($Res);
		$ret = "";
        
        $ret .= $this->template->LoadTemplate("global/cats_start.cphp", $this->lang->Phrase);
		$cnt = 0;

        foreach ($Cats as $val)
        {
             // Select the subcategories
			$sQuery = "SELECT * FROM `categories` WHERE `parent`='".$val['id']."'" . $Extra;
			$sRes = $this->mysql->Query($sQuery);
            $Subs = $this->mysql->FetchResults($sRes);
            $Am = $this->mysql->NumRows($sRes);

            // Display the main category
            $Title = str_replace(" ", $this->Settings['identifier'], $val['name']);
            $ret .= $this->template->LoadTemplate("global/cat.cphp",
                array(
					"title" => strtolower($Title), 
					"id" => $val['id'], 
					"name" => str_replace(array(" "),"_",$val['name']), 
					"display" => $val['name'], 
					"n" => $Am,
					"y" => $cnt,
				)
			);

			$cnt++;
            
            $Count = 0;
			foreach($Subs as $sCat)
            {
                $sTitle = str_replace(" ", $this->Settings['identifier'], $sCat['name']);
				$ret .= $this->template->LoadTemplate("global/scat.cphp",
                    array("title" => strtolower($sTitle), "id" => $sCat['id'], "name" => $sCat['name'], "parent" => $val['name'], "n" => $Count));
                $Count++;
			}

		}
        return $ret;
    }
    
    //---------------------------------------------------------
    // Name:    Error($Message)
    // Desc:    Output the message.
    //---------------------------------------------------------
    
    function Error($Message)
    {

        //-----------------------------------------------------------
		// Lets output the user error
		//-----------------------------------------------------------

		if(isset($this->lang->Phrase[$Message]))
			$Message = $this->lang->Phrase[$Message];

		$this->numError++;

		// Are we in a continuous loop i.e. memory leak?
		if ($this->numError >= 20 || count($this->MySQL) == 0) 
		{
			$URL = $_SERVER['SCRIPT_NAME'];
			$URL = str_replace('index.php', null, $URL);
			
			$scriptPath = ( $this->scriptPath == null && isset( $this->Wall->scriptPath ) ) ? $this->Wall->scriptPath : $this->scriptPath;

			$Error = file_get_contents($scriptPath . "templates/error.cphp");
			$Replace = str_replace("&&error&&", $Message, $Error);

			if(strpos($URL, 'admin/') != 0)
				$URL = $scriptPath;

			$Out = str_replace("&&path&&",$URL, $Replace);

			echo $Out;
			exit;
		}

		$this->Settings['path'] = isset($this->file->return['path']) ? $this->file->return['path'] : null;
		$this->Settings['title'] = "Error - ".$this->Settings['Site_Title'];

		// Call the error file
		$_REQUEST['act'] = "error";
		$this->lang->Phrase['out_err_msg'] = $Message;
		$this->auto_run();
		return false;

		/*
		Wallpaper::BuildHeader();

		// Categories
        $this->Output .= $this->template->LoadTemplate("global/boxthin_left.cphp", $this->file->return);
		$this->Output .= $this->CompileCategories();
		$this->Output .= $this->CompilePartners();
		$this->Output .= $this->template->LoadTemplate("global/cats_end.cphp", $this->file->return);

		// Output the error
		$Message = '<strong>' . $this->lang->Phrase['Generic_error'] . '</strong> '.$Message;
		$this->Output .= $this->template->LoadTemplate("global/error.cphp", array("message" => $Message));

		Wallpaper::BuildFooter();

		echo $this->Output;
		exit;
		*/
    }
    
	//---------------------------------------------------------
    // Name:    UserDetails()
    // Desc:    Grab the user details.
    //---------------------------------------------------------
    
    function UserDetails()
    {
		global $_COOKIE;
        
        // Added version 1.01
        $Cook = array_map("addslashes", $_COOKIE);
        
		if (functions::check_logged() == true)
		{
			$Query = "SELECT * FROM `users` WHERE `email`='" . $Cook['username'] . "' OR username = '" . $Cook['username'] . "'";
			$Res = $this->mysql->Query($Query);
			$this->User = $this->mysql->FetchResults($Res);
		}
		if(count($this->User) > 0)
			$this->User = $this->User[0];
        
    }

    //---------------------------------------------------------
    // Name:    Settings()
    // Desc:    Grab the settings from the database.
    //---------------------------------------------------------
    
    function Settings()
    {
        $Query = "SELECT * FROM `settings`";
        $Res = $this->mysql->Query($Query);
        $tmp = $this->mysql->FetchResults($Res);
        
        foreach($tmp as $val) {
            $this->Settings[$val['identifier']] = $val['value'];
        }
        
    }
    
    //---------------------------------------------------------
    // Name:    Data($Name)
    // Desc:    Retrieve sanitized POST or GET or COOKIE data.
    //---------------------------------------------------------
    
    function Data($Name,$Add = true)
    {
		$val = null;
        if(array_key_exists($Name,$this->_REQUEST))
			$val = $this->_REQUEST[$Name];

		// If it is not an array, let's handle it directly.
		if(!is_array($val))
		{
			// Do we have get_magic_quotes_gpc currently enabled?
			if( get_magic_quotes_gpc() ) {
				return $val;
			} else {
				$val = ($Add == true) ? addslashes($val) : $val;
			}

		// If it is an array, let's sanitize each element.
		} else {
			if( ! function_exists( 'gpc_sanitize' ) ) {
				function gpc_sanitize($el) {
					if( get_magic_quotes_gpc() ) {
						return $el;
					} else return addslashes( $el );
				}
			}
			if($Add == true) {
				$val = array_map('gpc_sanitize', $val);
			}
		}

        return $val;
        
    }

	//---------------------------------------------------------
	// Name:	IPAddr
	// Desc:	Retrieves the user's IP address
	//---------------------------------------------------------

	function IPAddr()
	{
		global $_SERVER;
		return $_SERVER['REMOTE_ADDR'];
	}
    
    //---------------------------------------------------------
    // Name:    ConnMysql($Details)
    // Desc:    Connects to the database.
    //---------------------------------------------------------
    
    function ConnMySql($Details)
    {
        // MySQL isn't even an array
        if (!is_array($Details)) {
            $this->Error($this->lang->Phrase['mysql_notarray']);
        }
        
        // No mysql host
        if (!isset($Details['host']) || ($Details['host'] == NULL)) {
            $this->Error($this->lang->Phrase['mysql_nohost']);
        }
        
        // No mysql db
        if (!isset($Details['database']) || $Details['database'] == NULL) {
            $this->Error($this->lang->Phrase['mysql_nodb']);
        }
        
        // No mysql user
        if (!isset($Details['username']) || $Details['username'] == NULL) {
            $this->Error($this->lang->Phrase['mysql_nouser']);
        }
        
        // Connect to the database
        $this->cn = mysql_connect($Details['host'], $Details['username'], $Details['password']) or
                        $this->Error($this->lang->Phrase['mysql_conn']."\n".mysql_error());
        
        @mysql_select_db($Details['database']) or $this->Error($this->lang->Phrase['mysql_db']."\n".mysql_error());
        
        $this->MySQL = $Details;
        
    }
    
    //---------------------------------------------------------
    // Name:    BuildHeader()
    // Desc:    Build the site header
    //---------------------------------------------------------
    
    function BuildHeader()
    {
		if(count($this->page) > 0)
		{
			foreach($this->page as $ide => $val)
				$this->Settings[$ide] = $val;
		}
	
        $this->lang->Phrase['Template'] = $this->Settings['Template'];

		// Meta tags
		$Meta = array();

		$Meta['meta_keywords'] = array_key_exists('meta_keywords', $this->lang->Phrase) == false ? $this->Settings['Meta_Keywords'] : $this->lang->Phrase['meta_keywords'];
		$Meta['meta_desc'] = array_key_exists('meta_desc', $this->lang->Phrase) == false ? $this->Settings['Meta_Description'] : $this->lang->Phrase['meta_desc'];

		// Analytics
		$Meta['analytics'] = $this->Settings['google_analytics'] == '1' ? str_ireplace('(number)', $this->Settings['google_analytics_code'], $this->Settings['analytics_code']) : null;

		$this->Settings = array_merge($this->Settings, $Meta);
        $this->Output .= $this->template->LoadTemplate("header.cphp", $this->Settings);

		if(array_key_exists('username', $this->User))
			$userLogged = $this->template->LoadTemplate("login/header_logged_in.cphp", array());
		else
			$userLogged = $this->template->LoadTemplate("login/header_not_logged_in.cphp", array());

        $this->Output .= $this->template->LoadTemplate("navigation.cphp", array_merge($this->Settings, array("login_code" => $userLogged)));
        $this->Output .= $this->template->LoadTemplate("content.cphp");
    }
    
    //---------------------------------------------------------
    // Name:    BuildFooter()
    // Desc:    Build the site footer
    //---------------------------------------------------------
    
    function BuildFooter()
    {
        $this->Output .= $this->template->LoadTemplate("footer.cphp", array_merge($this->lang->Phrase, $this->Settings));
    }
    
    
    //---------------------------------------------------------
    // Name:    Display()
    // Desc:    Display the page HTML
    //---------------------------------------------------------
    
    function Display()
    {
        if (is_array($this->Replace))
        {
            foreach ($this->Replace as $ide => $val)
            {
                $this->Output = str_replace("&&" . $ide . "&&", $val, $this->Output);
            }
        }

		// Replace non-english characters in url?
		$this->Output = functions::ReplaceLinks($this->Output);

        echo $this->Output;
    }
    
}


// Let's run the class!
if(!isset($Path)) $Path = null;
if(!isset($Admin)) $Admin = null;
$Wallpaper = new Wallpaper($Path, $Admin);



?>