<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: NotFound
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class NotFound
{
	var $class;
	var $return;

	function run()
	{
		$Script = $_SERVER['SCRIPT_NAME'];
		$Directory = preg_replace('/\w+\.\w+/', null, $Script);
		$RelativeURI = str_replace($Directory, null, $_SERVER['REQUEST_URI']);

		//-----------------------------------------------------------
		// Let's find out the relative path
		//-----------------------------------------------------------

		$Path = str_replace($Directory, null, $_SERVER['REQUEST_URI']);
		$Am = substr_count($Path, '/');

		$Path = null;
		for($x = 0; $x < $Am; $x++)
			$Path .= '../';

		//-----------------------------------------------------------
		// CUSTOM HTACCESS REWRITE RULES
		//-----------------------------------------------------------
		// This was the only method I could think of. 
		// If you have a better alternative, please let me know.
		//-----------------------------------------------------------

		// Sift rewrite rules in to an array
		$Rewrite = functions::rewrite_arr( $this->class->Settings['custom_rewrite'] );

		// Loop through rewrite rules
		foreach($Rewrite as $Rule)
		{
			$Pattern = $Rule[0];
			$Match = $Rule[1];

			if( substr($Pattern, 0, 1) != "/" ) $Pattern = "/" . $Pattern;
			if( substr($Pattern, -1) == "/" && substr($Pattern, strlen($Pattern) - 2, 1) == '\\') $Pattern .= "/";
			if( substr($Pattern, -1) != "/" ) $Pattern .= "/";

			// Does the current URI match a specific rule?
			if( preg_match( $Pattern, $RelativeURI, $Matches ) )
			{
				$URL = $Match;

				// Are there any variables we need to replace?
				foreach($Matches as $Ide => $Mat)
				{
					if( strpos( $Match, '$' . $Ide ) <> 0 )
						$URL = str_replace( '$' . $Ide, $Mat, $URL);
				}

				// Figure out file to include, and variables to pass through.
				if( strpos( $URL, '?' ) )
				{
					$Vars = explode( '?', $URL );

					$Include = $Vars[0];
					$Vars = $Vars[1];

					$Vars = explode( '&', $Vars );

					// Reset the input arrays
					unset($_GET);
					unset($_REQUEST);
					$_REQUEST = array();
					$_GET = array();

					// Populate input arrays
					foreach($Vars as $Variable)
					{
						$tmp = explode( '=', $Variable );
						$_GET[ $tmp[0] ] = addslashes( $tmp[1] );
						$_REQUEST[ $tmp[0] ] = addslashes( $tmp[1] );
					}

				} else $Include = $URL;

				// Does the include file even exist?
				if( ! file_exists( $Include ) )
				{
					$this->return['path'] = $Path;
					$this->class->Error( 'Custom rewrite error. File \'' . $Include . '\' does not exist.' );
				}

				$Current = str_replace( $Directory, null, $Script );

				$New = false;

				// Are we running an index.php file?
				if( strtolower( $Current ) == strtolower( $Include ) )
				{
					// Already included, can't include again. Bleh, this is going to be a pain.
					// If the act is different, proceed, if not, nothing we can do.
					
					// Is the act set?
					if( isset( $_GET['act'] ) )
					{
						if ( array_key_exists($_GET["act"], $this->class->files) || file_exists( 'sources/public/' . $_GET["act"] . '.php' ) || file_exists( 'sources/private/' . $_GET["act"] . '.php' ) )
						{
							// What file are we including?
							if( file_exists( 'sources/public/' . $_GET['act'] . '.php' ) )
								$File = 'sources/public/' . $_GET['act'] . '.php';
							
							else if( file_exists( 'sources/private/' . $_GET['act'] . '.php' ) )
								$File = 'sources/private/' . $_GET['act'] . '.php';

							if( ! isset( $File ) )
							{
								$File = $this->class->files[ $_GET['act'] ][1];
								$Class = $this->class->files[ $_GET['act'] ][0];

							} else $Class = $_GET['act'];

							// Load and execute the class
							include_once( $File );
							$Include = new $Class();
							
							$Include->class = $this->class;
							$Ret = $Include->run();
							$this->return = $Include->return;

							// Retrieved, let's return.
							return $Ret;

						} else
						{
							// The file we're trying to include does not exist. Nothing we can do here.
						}

					} else
					{
						// Act is not set. Nothing we can do here.
					}
				} else
				{
					// Not index.php. We can include it.
					if( file_exists( $Include ) )
					{
						include_once( $Include );

						if( isset( $_GET['act'] ) && class_exists( $_GET['act'] ) )
						{
							$Include = new $_GET['act']();
							return $Include->run();
						}
					} // Else file doesn't exist. Nothing we can do.
				}

			}
		}

		//-----------------------------------------------------------
		// No redirection applies, lets just output the 404
		//-----------------------------------------------------------

		if($this->class->Settings['file_not_found'] == '2')
		{
			$this->return['path'] = $Path;
			$this->class->Error( $this->class->lang->Phrase['f04_message'] . "<br />" . $_SERVER['REQUEST_URI'] );
		} else if($this->class->Settings['file_not_found'] == '1')
		{
			header("Location: " . $Path . "index.php");

		} else if($this->class->Settings['file_not_found'] == '3')
		{
			$this->return['path'] = $Path;

			if($this->class->Settings['file_not_found_custom'] == null)
				$this->class->Error( "f04_noscript" );

			if( ! file_exists($this->class->Settings['file_not_found_custom']) )
				$this->class->Error( $this->class->lang->Phrase['f04_message'] . " <br />" . $_SERVER['REQUEST_URI'] );

			include_once($this->class->Settings['file_not_found_custom']);
			exit;
		}
	}
}

?>
		