<?php

$Admin = true; // While we're not in the admin panel, running it in admin mode will ensure the main framework is not executed.
include_once("../../index.php");

// Retrieve photo details
$Filename = (isset($_GET['f'])) ? $_GET['f'] : null;
$Width = (isset($_GET['w'])) ? $_GET['w'] : null;
$Height = (isset($_GET['h'])) ? $_GET['h'] : null;
$Crop = ( isset($_GET['crop'] ) ) ? true : false;

// Directory
$Dir = dirname( __FILE__ );

// Photo we want
$Photo = WS_PATH . "/" . urldecode( $Filename );

// Does the photo exist?
if( ! file_exists( $Photo ) ) {
	die( sprintf( "Photo does not exist (%s)", $Photo ) );
}

// Height and width entered?
if( is_null( $Width ) OR is_null( $Height ) ) {
	die( "You must enter a width and height." );
}

// The directory path
$Directory = WS_PATH . "/tmp/cache";

// Do we have to create the cache directory?
if( ! is_dir( $Directory ) ) {
	mkdir( $Directory, 0777, true );
	chmod( $Directory, 0777 );
}

// Does the cache file exist?
$File = $Directory . "/" . urlencode($Filename) . "_" . $Width . "x" . $Height . ".jpg";

//-----------------------------------------------------
// Create the cached file?
//-----------------------------------------------------

if( ! file_exists( $File ) )  {
	// Are we cropping the image?
	if( $Crop == true ) {
		// File extension
		$type = strtolower( substr( $Photo, strrpos( $Photo, "." ) + 1, strlen( $Photo ) ) );
		
		// Retrieve width and height of the photo
		list($curWidth, $curHeight) = getimagesize( $Photo );

		// Loop through until we get the dimensions we want.
		$n = 0;
		while( (int) $curWidth > (int) $Width && (int) $curHeight > (int) $Height ) {
			$curWidth /= 1.001;
			$curHeight /= 1.001;
			$n++;
		}

		$curWidth = floor( $curWidth );
		$curHeight = floor( $curHeight );
		
		// Create the temporary file
		$TmpFile = WS_PATH . "/tmp/cache/tmp" . rand(10000000,10000000000);
		resizeImage( $Photo, $TmpFile, $curWidth, $curHeight);
		
		// Create images to crop
		$image_p = imagecreatetruecolor($Width, $Height);
		$image = imagecreatefromjpeg($TmpFile);
		imagecopyresampled($image_p, $image, 0, 0, 0, 0, $Width, $Height, $Width, $Height);
		
		// What image are we creating?
		switch($type) {
			case 'jpg':
				imagejpeg($image_p,$File,100);
				break;
			case 'jpeg':
				imagejpeg($image_p,$File,100);
				break;
			case 'gif':
				imagegif($image_p,$File,100);
				break;
			case 'png':
				imagepng($image_p,$File,9);
				break;
			case 'wbm':
				imagewbmp($image_p,$File,100);
				break;
			default:
				imagejpeg($image_p,$File,100);
				break;
		}
		imagedestroy($image_p);
		imagedestroy($image);
		
		// Delete the temporary file
		unlink($TmpFile);
	
	} else {
		// Just delete the image
		resizeImage( $Photo, $File, $Width, $Height );
	}
}

// What header to output?
$Type = strtolower( substr( $Filename, strrpos( $Filename, "." ) + 1, strlen( $Filename ) ) );
switch( $Type ) {
	case "gif": $ctype="image/gif"; break;
	case "png": $ctype="image/png"; break;
	case "jpeg":
	case "jpg": $ctype="image/jpg"; break;
}
header("Content-Type: " . $ctype);

// Output the image
print file_get_contents( $File );

// Resize an image (current file, new file path, width, height)
function resizeImage($file, $filename, $newwidth=160, $newheight=120)
{
	$type = substr($file,strrpos($file,".")+1);

	switch($type) 
	{
		case 'jpg':
			$src = imagecreatefromjpeg($file);
			break;
		case 'jpeg':
			$src = imagecreatefromjpeg($file);
			break;
		case 'gif':
			$src = imagecreatefromgif($file);
			break;
		case 'png':
			$src = imagecreatefrompng($file);
			break;
		default:
			$src = imagecreatefromjpeg($file);
			break;
	}

	list($width,$height)=getimagesize($file);
	$tmp=imagecreatetruecolor($newwidth,$newheight);
	imagecopyresampled($tmp,$src,0,0,0,0,$newwidth,$newheight,$width,$height);

	switch($type) {
		case 'jpg':
			imagejpeg($tmp,$filename,100);
			break;
		case 'jpeg':
			imagejpeg($tmp,$filename,100);
			break;
		case 'gif':
			imagegif($tmp,$filename,100);
			break;
		case 'png':
			imagepng($tmp,$filename,9);
			break;
		case 'wbm':
			imagewbmp($tmp,$filename,100);
			break;
		default:
			imagejpeg($tmp,$filename,100);
			break;
	}
	imagedestroy($src);
	imagedestroy($tmp);
	return true;
}

?>