<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Categories
|   > Script written by Alex Roxon
|   > Date started: Apr 30 2009
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Categories
{

	var $class;
	var $return = array();
	var $Output;
	var $Stats = array();

	var $WallpapersPerPage;

	function run()
	{
		//-------------------------------------------------
		// Where are we going?
		//-------------------------------------------------

		$this->WallpapersPerPage = $this->class->Settings['cats_per_page'];

		switch($this->class->Data("action"))
		{
			case 'create_sid':
				return $this->create_sid();
				break;
			case 'downloads':
				return $this->downloads();
				break;
			case 'top_rated':
				return $this->top_rated();
				break;
			case 'top_viewed':
				return $this->top_viewed();
				break;
			case 'comments':
				return $this->comments();
				break;
			/*
			case 'all':
				return $this->all();
				break;
			
			case 'filter':
				return $this->filter();
				break;
			*/
		}

		$filt = null;
		$pag = null;
		$catExtra = null;
		$wallHTML = null;
		$catTitle = null;

		// Path works regardless of the request URI
		$end = substr($_SERVER['REQUEST_URI'], -1);
		$this->return['path'] = ($end === "/") ? "../" : (strtolower($end) == "l") ? (is_numeric(str_replace(array(".html", "index", "-", " ", "_"), null, substr($_SERVER['REQUEST_URI'], strrpos($_SERVER['REQUEST_URI'], "/")+1))) && strpos($_SERVER['REQUEST_URI'], "filter") <> 0) ? "../../" : "../" : "";

		if($this->class->Data("mode") == "top" || $this->class->Data("mode") == "latest") $this->return['path'] = null;

		//-------------------------------------------------
		// Let's get the category information right
		//-------------------------------------------------

		$uCat = ($this->return['path'] == "") ? str_replace(substr($_SERVER['REQUEST_URI'],0,strrpos($_SERVER['REQUEST_URI'], "/")+1), null, $_SERVER['REQUEST_URI']) . "/" : "";

		$rpath = (strpos($_SERVER['REQUEST_URI'],"filter") <> 0) ? "../" : null;

		$catID = $this->class->Data("id");
		$catID = str_replace("/", null, $catID);

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-------------------------------------------------
		// Are we filtering results?
		//-------------------------------------------------

		if (strpos($_SERVER['REQUEST_URI'], "filter") <> 0)
		{
			
			// Get the filter settings
			if (! is_numeric($this->class->Data("id")))
				$this->class->Error($this->class->lang->Phrase['cat_invFilt']);

			$filt = true;

			$URI = $_SERVER['REQUEST_URI'];
			preg_match_all('/filter\/index(\d+)_(\d+).html/', $URI, $Res);
			
			if(isset($Res[0][0]))
			{
				$Page = $Res[2][0];
				$FilterId = $Res[1][0];
				$this->class->lang->Phrase['cat_ind'] = "index" . $FilterId;
				$ext = '_';

			} else $FilterId = $this->class->Data("id");

			//---------------------------------------------
			// Run the query, retrieve the results
			//---------------------------------------------

			$Query = "SELECT * FROM `filter_sessions` WHERE `id` = " . $FilterId;
			$Result = $this->class->mysql->Query($Query);
			$Filter = $this->class->mysql->FetchResults($Result);
			$Filter = $Filter[0];
	
			if (count($Filter) == 0)
				$this->class->Error($this->class->lang->Phrase['cat_sesIdInv']);
			
			$catID = $Filter['cat'];
			$Sort = $Filter['sort'];
			$Order = $Filter['order'];
			$Time = intval($Filter['time']);

			//---------------------------------------------
			// What are we sorting by?
			//---------------------------------------------

			switch(strtolower($Sort))
			{
				case "votes":
					$SortCaption = $this->class->lang->Phrase['cat_sortRat'];
					break;
				case "time":
					$SortCaption = $this->class->lang->Phrase['cat_sortDat'];
					break;
				case "downloads":
					$SortCaption = $this->class->lang->Phrase['cat_sortDls'];
					break;
				case "name":
					$SortCaption = $this->class->lang->Phrase['cat_sortNam'];
					break;
				case "author":
					$SortCaption = $this->class->lang->Phrase['cat_sortAut'];
					break;
				case "comments":
					$SortCaption = $this->class->lang->Phrase['cat_sortCom'];
					break;
				case "views":
					$SortCaption = $this->class->lang->Phrase['cat_sortVie'];
					break;
			}

			$OrderCaption = ($Order == "desc") ? $this->class->lang->Phrase['cat_sortDesc'] : $this->class->lang->Phrase['cat_sortAsc'];

			//---------------------------------------------
			// What time are we filtering by?
			//---------------------------------------------

			switch($Time)
			{
				case 45:
				case 2:
				case 10:
				case 75:
				case 100:
					$TimeCaption = str_replace('{x}', $Time, $this->class->lang->Phrase['cat_lastXDays']);
					break;
				case 1:
					$TimeCaption = $this->class->lang->Phrase['cat_lastDay'];
					break;
				 case 7:
					$TimeCaption = $this->class->lang->Phrase['cat_lastWeek'];
					break;
				 case 14:
					$TimeCaption = $this->class->lang->Phrase['cat_last2Weeks'];
					break;
				 case 30:
					$TimeCaption = $this->class->lang->Phrase['cat_lastMonth'];
					break;
				 case 60:
					$TimeCaption = $this->class->lang->Phrase['cat_last2Months'];
					break;
				 case 365:
					$TimeCaption = $this->class->lang->Phrase['cat_lastYear'];
					break;
				 case -1:
					$TimeCaption = $this->class->lang->Phrase['cat_Beginning'];
					break;
			}
				

			//---------------------------------------------
			// Some miscellaneous tasks
			//---------------------------------------------

			if ($Sort == "votes") 
			{
				$Sort = "votes` / `votecount";
				$Order = ($Order == "asc") ? "desc" : "asc";
			}

			$Time =  ($Filter['time'] != -1) ? time() - (intval($Filter['time'])  * 60 * 60 * 24) : $Filter['time'];

			// Get the extra filter html
			$filter_extra = $this->class->template->LoadTemplate("categories/filter_extra.cphp", array(
					"sort"		=> $SortCaption,
					"order"		=> $OrderCaption,
					"time"		=> $TimeCaption,
			));

		//-----------------------------------------------------------
		// Top Rated Wallpapers
		//-----------------------------------------------------------

		} else if ($this->class->Data("mode") == "top")
		{
			if($this->class->Settings['show_top_wallpapers'] != '1')
				$this->class->Error($this->class->lang->Phrase['feature_disabled']);

			$catID = '1 OR 1=1';
			$Sort = "votecount` / `votes";
			$Order = "desc";
			$Time = 0;
			$filter_extra = null;
			$this->return['path'] = "";
			$catTitle = "Top Rated";
			$this->class->lang->Phrase['cat_ind'] = 'top_wallpaper';

		//-----------------------------------------------------------
		// Latest Wallpapers
		//-----------------------------------------------------------

		} else if ($this->class->Data("mode") == "latest")
		{
			if($this->class->Settings['show_latest_wallpapers'] != '1')
				$this->class->Error($this->class->lang->Phrase['feature_disabled']);

			$catID = '1 OR 1=1';
			$Sort = "time";
			$Order = "desc";
			$Time = 0;
			$filter_extra = null;
			$this->return['path'] = "";
			$catTitle = "Latest";
			$this->class->lang->Phrase['cat_ind'] = 'latest_wallpaper';

		} else
		{
			$Sort = "id";
			$Order = "desc";
			$Time = 0;
			$filter_extra = null;
		}


		//-------------------------------------------------
		// Let's run some queries! 
		//-------------------------------------------------

		// Select the main category
		$Query = "SELECT * FROM `categories` WHERE `id` = ".$catID;
		$Result = $this->class->mysql->Query($Query);
		$Category = $this->class->mysql->FetchResults($Result);
		$catTitle = ($catTitle == null) ? $Category[0]['name'] : $catTitle;

		// Get any subcategories
		$Query = "SELECT `id` FROM `categories` WHERE `parent`='" . $catID . "'";
		$Result = $this->class->mysql->Query($Query);
		$Subs = $this->class->mysql->FetchResults($Result);

		$q = $catID;
		if (count($Subs) > 0)
			foreach($Subs as $val)
				$q .= " OR `cat`= " . $val['id'];

		if($this->class->Settings['cat_stats'] == '1')
		{

			//-------------------------------------------------
			// Get total amount of wallpapers in category.
			//-------------------------------------------------

			$Query = "SELECT COUNT(*), SUM(downloads), SUM(views) FROM `wallpapers` WHERE `cat` = " . $q;
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			$Amount = $Res[0]['COUNT(*)'];
			$Pages = ceil($Amount / $this->WallpapersPerPage);

			$this->Stats['count'] = number_format($Res[0]['COUNT(*)']);
			$this->Stats['downloads'] = number_format($Res[0]['SUM(downloads)']);
			$this->Stats['views'] = number_format($Res[0]['SUM(views)']);

			$Query = "SELECT author, COUNT(*) FROM `wallpapers` WHERE `cat` = $q AND author != '' GROUP BY author LIMIT 1";
			$Result = $this->class->mysql->Query($Query);
			$TopUser = $this->class->mysql->FetchResults($Result);

			if(isset($TopUser[0]))
			{
				$TopUser = $TopUser[0];

				$this->Stats['user'] = utf8_encode(strtolower(str_replace(' ', null, $TopUser['author'])));
				$this->Stats['username'] = $TopUser['author'];
				$this->Stats['useram'] = number_format( (int) $TopUser['COUNT(*)'] );

			} else
			{
				$this->Stats['user'] = '';
				$this->Stats['username'] = '';
				$this->Stats['useram'] = '';
			}


			//-------------------------------------------------
			// Get the total amount of comments
			//-------------------------------------------------

			$Query = "SELECT COUNT(comments.id) FROM `wallpapers` INNER JOIN comments ON wallpapers.id = comments.wid WHERE cat = " . $q . " GROUP BY wallpapers.id DESC";
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);

			$comments = 0;
			foreach($Res as $val)
				$comments = $comments + intval($val['COUNT(comments.id)']);
			
			$this->Stats['comments'] = number_format($comments);

			//-------------------------------------------------
			// Get the average rating
			//-------------------------------------------------

			$Query = "SELECT AVG(votecount / votes) FROM `wallpapers` WHERE cat = ".$q;
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			$this->Stats['rating'] = round($Res[0]['AVG(votecount / votes)'], 1);

			$catStats = $this->class->template->LoadTemplate("categories/stats.html", array());
		}


		//-------------------------------------------------
		// Let's get started on the pagination!
		//-------------------------------------------------

		if($this->class->Settings['cats_pag'] == '1')
		{

			$Page = (! isset($Page) || $Page == null) ? intval($this->class->Data("page")) : $Page;
			$Page = ($Page == null) ? $Page = 1 : $Page;
			$pagHTML = null;

			// Extra
			$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page : null;
			$Start = ($Page * $this->WallpapersPerPage) - $this->WallpapersPerPage;

			if(! isset($ext) && $filt == true)
				$ext = $this->class->Data("id") . "_";
			elseif ($filt == false) $ext = null;

			// If we are viewing all
			if ($this->class->Data("mode") == "all")
				$Pages = 1;
			
			$pagHTML = functions::pagHTML($Page, $Pages, $ext,"categories/cat_","LoadComments");
		}

		//-------------------------------------------------
		// Retrieve the wallpaper
		//-------------------------------------------------

		$Query = "SELECT * FROM `wallpapers` WHERE (`cat` = ".$q .") AND `time` > ".$Time." AND `status` = 1 ORDER BY `".$Sort."` ".$Order;
		
		if($this->class->Settings['cats_pag'] == '1')
		{
			if ($this->class->Data("mode") != "all")
				$Query .= " LIMIT ".$Start.",".$this->WallpapersPerPage;
		}
			
		$Result = $this->class->mysql->Query($Query);
		$Wallpapers = $this->class->mysql->FetchResults($Result);

		$CatsArr = array();


		if(count($Wallpapers) == 0)
		{
			// There are no wallpapers
			if ($Page > 1)
				$wallHTML = $this->class->template->LoadTemplate("categories/empty_result.cphp", array());
			else $wallHTML = $this->class->template->LoadTemplate("categories/no_wallpapers.cphp", array("category" => $catTitle));

		} else
		{
			$pag = $pagHTML;

			$Query = "SELECT `name`, `id` FROM `categories`";
			$Result = $this->class->mysql->Query($Query);
			$Cats = $this->class->mysql->FetchResults($Result);
			
			foreach($Cats as $Cat)
				$CatsArr[$Cat['id']] = $Cat['name'];

			foreach($Wallpapers as $Wallpaper)
			{
				if( file_exists( $this->class->Settings['Template'] . "templates/home/homestar.cphp" ) ) 
				{
					if( $Wallpaper['votes'] > 0 ) {
						$Rating = floor( (int) $Wallpaper['votecount'] / (int) $Wallpaper['votes'] );
					} else $Rating = 0;

					$Star = null;
					for( $x = 1; $x <= 5; $x++ ) {
						$Num = ( $Rating < $x ) ? 2 : 1;
						$Star .= $this->class->template->LoadTemplate("home/homestar.cphp", array("img" => $Num));
					}	
				} else $Star = null;

				$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$Wallpaper['cat']])));
				
				$wallHTML .= $this->class->template->LoadTemplate("categories/wallpaper.cphp", array(
						"thumb"		=> $Wallpaper['thumbSmall'],
						"desc"		=> $Wallpaper['desc'],
						"name"		=> $Wallpaper['name'],
						"path"		=> $this->return['path'],
						"star"		=> $Star,
						"category"	=> $catTitle,
						"id"		=> $Wallpaper['id'],
						"rating"	=> $Rating,
						"url"		=> $CatUrl . "/" . utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $Wallpaper['name']))). $this->class->Settings['identifier'] . $Wallpaper['id'].".html",
				));
			}
		}

		$Extra = ($this->class->Data("mode") == "all") ? $this->class->lang->Phrase['cat_viewAllWal'] : $Extra;

		//-------------------------------------------------
		// Output the global HTML
		//-------------------------------------------------
		
		$this->Output .= $this->class->template->LoadTemplate("categories/global.cphp", array_merge(array(
				"cid"			=> $catID,
				"ucat"			=> $uCat,
				"whtml"			=> $wallHTML,
				"catTitle"		=> $catTitle,
				"pag"			=> $pag,
				"rpath"			=> $rpath,
				"extra"			=> $Extra,
				"filter_extra"	=> $filter_extra,
				"catExtra"		=> $catExtra,
				"stats"			=> $catStats,
			), $this->Stats)
		);

		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page." " : $Extra;

		$this->class->page['title'] = $this->class->Settings['category_page_title'];
		$this->class->page['title'] = str_replace('(website)', $this->class->Settings['Site_Title'], $this->class->page['title']);
		$this->class->page['title'] = str_replace('(category)', $catTitle, $this->class->page['title']);
		
		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    create_sid()
    // Desc:    Create a search id to save to the db
    //---------------------------------------------------------

	function create_sid()
	{
		
		//---------------------------------------
		// Retrieve the variables
		//---------------------------------------

		$Sort = $this->class->Data("sort");
		$Order = $this->class->Data("order");
		$Time = $this->class->Data("time");
		$Cat = $this->class->Data("cat");

		// Unique key
		$Unique = $Sort . $Order . $Time .  $Cat . rand(1,10000000);

		//---------------------------------------
		// Database queries
		//---------------------------------------

		$Query = "INSERT INTO `filter_sessions` (`sort`,`order`,`time`,`cat`,`unique`) VALUES('$Sort','$Order','$Time','$Cat','$Unique')";
		$Result = $this->class->mysql->Query($Query);

		$Query = "SELECT * FROM `filter_sessions` WHERE `unique`='$Unique'";
		$Result = $this->class->mysql->Query($Query);
		$Session = $this->class->mysql->FetchResults($Result);

		echo $Session[0]['id'];
		exit;

	}

}

?>