<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Search
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Search 
{

	var $class;
	var $return = array();
	var $Output;

	function run()
	{
		return $this->defaultForm();
	}

	function defaultForm()
	{
		// Are we running a search request?
		$URL = $_SERVER['REQUEST_URI'];
		preg_match_all("/(\w+)\=(\w+)/", $URL, $Vars);
		
		if($this->class->Data("terms") != null)
		{
			$Vars[0][0] = 'terms=' . $this->class->Data("terms");
			$Vars[1][0] = 'terms';
			$Vars[2][0] = $this->class->Data("terms");

			if( $this->class->Data("page") != "" && is_numeric( $this->class->Data("page") ) ) {
				$Vars[1][1] = "page";
				$Vars[2][1] = $this->class->Data("page");
			}
		}
		
		if(array_key_exists(1, $Vars) && array_key_exists(0, $Vars[1]))
			return $this->DisplaySearch($Vars);

		$this->return['path'] = "";
		$this->class->page['title'] = "Search Wallpapers - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		
		//-----------------------------------------------------------
		// Get the categories and subcategories
		//-----------------------------------------------------------

		$Query = "SELECT * FROM `categories`";
		$Res = $this->class->mysql->Query($Query);
		$Categories = $this->class->mysql->FetchResults($Res);

		$Structure = array();
		$Subs = array();
		foreach($Categories as $Cat) 
		{
			if ($Cat['parent'] == 0)
				$Structure[$Cat['id']] = array("name" => $Cat['name'], "Sub" => array());
			else $Subs[] = $Cat;
		}

		foreach($Subs as $Sub) 
			$Structure[$Sub['parent']]['Sub'][$Sub['id']] = $Sub['name'];

		asort($Structure);

		$Options = null;
		foreach($Structure as $id => $Cat)
		{
			$Options .= "<option value='".$id."'>".$Cat['name']."</option>\n";
			foreach($Cat['Sub'] as $sid => $scat)
				$Options .= "<option value='".$sid."'>&nbsp;&nbsp;&nbsp;&#0124;-- ".$scat."</option>\n";
		}

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("misc/search.cphp", array(
				'cats'		=> $Options,	
		));

		return $this->Output;

	}

	function DisplaySearch($Vars)
	{

		$Search = array();
		foreach($Vars[1] as $ide => $val)
		{
			if(strtolower($val) == 'cat') $Search[$val][] = addslashes($Vars[2][$ide]);
			else $Search[$val] = addslashes($Vars[2][$ide]);
		}

		// Check to see if we found anything, or whether or not we should output an error.
		$Found = false; 
		foreach( $Search as $Form ) {
			if( is_numeric( $Form ) && $Form > 0 ) {
				$Found = true;
				break;
			} elseif( ! is_numeric( $Form ) && strlen( $Form ) > 0 ) {
				$Found = true;
				break;
			}
		}

		if( $Found == false ) 
			$this->class->Error( "You must enter parameters to search." );

		// Enter search field?
		if( ! isset( $Search["terms"] ) )
			$this->class->Error( "You must enter search parameters." );
	
		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-------------------------------------------------
		// Let's initiate some variables
		//-------------------------------------------------

		$filt = false;
		$wallHTML = null;
		$uCat = null;
		$rpath = null;
		$catExtra = null;
		$Where = array();

		if(array_key_exists("terms", $Search) && !is_null($Search['terms']))
			$Where[] = "OR (`name` LIKE '%" . $Search['terms'] . "%'";

		if(array_key_exists("terms", $Search) && !is_null($Search['terms']) && !array_key_exists("titles_only", $Search))
			$Where[] = "OR `desc` LIKE '%" . $Search['terms'] . "%')";
		else
			if(array_key_exists("terms", $Search) && !is_null($Search['terms']))
				$Where[0] .= ")";

		if(array_key_exists("author", $Search) && !is_null($Search['author']))
			$Where[] = "AND `author` = '" . $Search['author'] . "'";

		if(array_key_exists("cat", $Search))
		{
			$w = "AND (";
			foreach($Search['cat'] as $cat)
				$w .= "`cat` = " . $cat . " OR ";
			$w = substr($w, 0, strlen($w)-4).')';
			$Where[] = $w;
		}

		if(array_key_exists("views", $Search) && is_numeric($Search['views']) && intval($Search['views']) > 0)
			$Where[] = "AND `views` > ".intval($Search['views']);


		$wQuery = null;
		foreach($Where as $query)
			$wQuery .= $query." ";

		$wQuery = substr($wQuery, 0, strlen($wQuery)-1);
			
		if(substr($wQuery, 0, 2) == "OR")
			$wQuery = substr($wQuery, 3); 
		elseif(substr($wQuery, 0, 3) == "AND")
			$wQuery = substr($wQuery, 4); 

		$catID = '1 OR 1=1';
		$Sort = "votecount` / `votes";
		$Order = "desc";
		$Time = 0;
		$filter_extra = null;

		$Path = ( strpos( strtolower( $_SERVER['REQUEST_URI'] ), "tags" ) ) <> 0 ? "../" : "";
		$this->return['path'] = $Path;
		

		$catTitle = "Search Results";
		$this->class->lang->Phrase['cat_ind'] = '';

		if($this->class->Settings['cat_stats'] == '1')
		{

			//-------------------------------------------------
			// Get total amount of wallpapers in category.
			//-------------------------------------------------

			$Query = "SELECT COUNT(*), SUM(downloads), SUM(views) FROM `wallpapers` WHERE " . $wQuery . " AND status = 1";
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			$Amount = $Res[0]['COUNT(*)'];
			$Pages = ceil($Amount / $this->class->Settings['cats_per_page']);

			$this->Stats['count'] = number_format($Res[0]['COUNT(*)']);
			$this->Stats['downloads'] = number_format($Res[0]['SUM(downloads)']);
			$this->Stats['views'] = number_format($Res[0]['SUM(views)']);

			$Query = "SELECT author, COUNT(*) FROM `wallpapers` WHERE $wQuery AND author != '' AND status = 1 GROUP BY author LIMIT 1";
			$Result = $this->class->mysql->Query($Query);
			$TopUser = $this->class->mysql->FetchResults($Result);

			$TopUser = isset( $TopUser[0] ) ? $TopUser[0] : null;

			$this->Stats['user'] = utf8_encode(strtolower(str_replace(' ', null, $TopUser['author'])));
			$this->Stats['username'] = $TopUser['author'];
			$this->Stats['useram'] = number_format( (int) $TopUser['COUNT(*)'] );

			//-------------------------------------------------
			// Get the total amount of comments
			//-------------------------------------------------

			$Query = "SELECT COUNT(comments.id) FROM `wallpapers` INNER JOIN comments ON wallpapers.id = comments.wid WHERE " . $wQuery . " AND status = 1 GROUP BY wallpapers.id DESC";
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);

			$comments = 0;
			foreach($Res as $val)
				$comments = $comments + intval($val['COUNT(comments.id)']);
			
			$this->Stats['comments'] = number_format($comments);

			//-------------------------------------------------
			// Get the average rating
			//-------------------------------------------------

			$Query = "SELECT AVG(votecount / votes) FROM `wallpapers` WHERE " . $wQuery . " AND status = 1";
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			$this->Stats['rating'] = round($Res[0]['AVG(votecount / votes)'], 1);

			$catStats = $this->class->template->LoadTemplate("categories/stats.html", array());
		}


		//-------------------------------------------------
		// Get total amount of wallpapers in category.
		//-------------------------------------------------
		$Pages = ceil($Amount / $this->class->Settings['cats_per_page']);

		#$Pages = 1;

		//-------------------------------------------------
		// Let's get started on the pagination!
		//-------------------------------------------------

		$Page = isset($Search['page']) ? intval(addslashes($Search['page'])) : null;
		$Page = (! isset($Page) || $Page == null) ? 1 : $Page;
		$pagHTML = null;

		$URI = ($_SERVER['REQUEST_URI']);
		$SearchString = (strrpos($URI, "/") <> 0) ? substr($URI, strrpos($URI, "/") + 1, strlen($URI)) : $URI;
		
		// Replace search
		$SearchString = preg_replace("/[\&page]+\=\d+/", null, $SearchString);
		

		// Extra
		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page : null;
		$Start = ($Page * $this->class->Settings['cats_per_page']) - $this->class->Settings['cats_per_page'];
		
		$ext = $SearchString . "&page=";

		//-------------------------------------------------
		// Retrieve the wallpaper
		//-------------------------------------------------

		// Get amount of pages
		$Pages = $this->class->mysql->Query("SELECT COUNT(*) FROM `wallpapers` WHERE ".$wQuery . " AND status = 1");
		$Pages = $this->class->mysql->FetchResults($Pages);
		$Pages = intval($Pages[0]['COUNT(*)']);

		$Query = "SELECT * FROM `wallpapers` WHERE ".$wQuery;
		if( stripos( $Query, "AND status" ) == 0 )
			$Query .= " AND status = 1";
		
		if ($this->class->Data("mode") != "all")
			$Query .= " LIMIT ".$Start.",".$this->class->Settings['cats_per_page'];

		$Result = $this->class->mysql->Query($Query);
		$Wallpapers = $this->class->mysql->FetchResults($Result);

		$Pages = ceil($Pages / intval($this->class->Settings['cats_per_page']));

		$pagHTML = functions::pagHTML($Page,$Pages,$ext,"categories/search/cat_","LoadComments");

		if(count($Wallpapers) == 0)
		{
			// There are no wallpapers
			if ($Page > 1)
				$wallHTML = $this->class->template->LoadTemplate("categories/empty_result.cphp", array());
			else $wallHTML = $this->class->template->LoadTemplate("categories/no_wallpapers.cphp", array("category" => $catTitle));
		} else
		{
			$pag = $pagHTML;

			$Query = "SELECT `name`, `id` FROM `categories`";
			$Result = $this->class->mysql->Query($Query);
			$Cats = $this->class->mysql->FetchResults($Result);
			
			foreach($Cats as $Cat)
				$CatsArr[$Cat['id']] = $Cat['name'];

			foreach($Wallpapers as $Wallpaper)
			{
				if( file_exists( $this->class->Settings['Template'] . "templates/home/homestar.cphp" ) ) 
				{
					if( $Wallpaper['votes'] > 0 ) {
						$Rating = floor( (int) $Wallpaper['votecount'] / (int) $Wallpaper['votes'] );
					} else $Rating = 0;

					$Star = null;
					for( $x = 1; $x <= 5; $x++ ) {
						$Num = ( $Rating < $x ) ? 2 : 1;
						$Star .= $this->class->template->LoadTemplate("home/homestar.cphp", array("img" => $Num));
					}	
				} else $Star = null;		

				$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$Wallpaper['cat']])));

				$wallHTML .= $this->class->template->LoadTemplate("categories/wallpaper.cphp", array(
						"thumb"		=> $Wallpaper['thumbSmall'],
						"desc"		=> $Wallpaper['desc'],
						"name"		=> $Wallpaper['name'],
						"path"		=> $this->return['path'],
						"category"	=> "Search Results",
						"rating"	=> $Rating,
						"star"		=> $Star,
						"url"		=> $CatUrl . "/" . utf8_encode(strtolower(str_replace(array(" "),'-', $Wallpaper['name']))).$this->class->Settings['identifier'].$Wallpaper['id'].".html",
				));
			}
		}

		$Extra = ($this->class->Data("mode") == "all") ? $this->class->lang->Phrase['cat_viewAllWal'] : $Extra;

		if(! isset($pag)) $pag = null;

		//-------------------------------------------------
		// Output the global HTML
		//-------------------------------------------------
		
		$this->Output .= $this->class->template->LoadTemplate("categories/global.cphp", array_merge(array(
				"cid"			=> $catID,
				"ucat"			=> $uCat,
				"whtml"			=> $wallHTML,
				"catTitle"		=> $catTitle,
				"pag"			=> $pag,
				"rpath"			=> $rpath,
				"extra"			=> $Extra,
				"filter_extra"	=> $filter_extra,
				"catExtra"		=> $catExtra,
				"stats"			=> $catStats,
			), $this->Stats)
		);

		// Clear
        $this->Output .= $this->class->template->LoadTemplate("global/clear.cphp", $this->return);

		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page." " : $Extra;

		$this->class->page['title'] = $catTitle . " " . $this->class->lang->Phrase['cat_titleWall'] ." " . $Extra . " | " .  $this->class->Settings['Site_Title'];
		
		return $this->Output;


	}

}

?>